;;;;;;;;;;;;;;;;;;;;;;;;;;;;;RUTA DEL PROGRAMA;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setq ruta "C:/Users/pedro/Documents/cursoedif")
(setq dirprograma "C:/Users/pedro/Documents/cursoedif")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;COMUNES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;subprogramas comunes que se usan mucho;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun nombrefich ()
	(setq dir (getvar "dwgprefix"))
	(setq nombre1 (substr (getvar "dwgname") 1 (- (strlen (getvar "dwgname")) 4)))
	(setq nombre (strcat dir nombre1))
)
(defun listasolid3d ()
	(setq lista nil)
	(setq liscap (tblnext "layer" ""))
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq ctrl (ssget "x" (list (cons 0 "solid3d") (cons 8 nomcap))))
	(if ctrl (setq lista (cons nomcap lista)))
	(while liscap
		(setq liscap (tblnext "layer"))
		(if liscap (setq nomcap (cdr (assoc 2 liscap))))
		(if liscap (setq ctrl (ssget "x" (list (cons 0 "solid3d") (cons 8 nomcap)))))
		(if (and liscap ctrl) (setq lista (cons nomcap lista)))
	)
	(setq lista (reverse lista))
	(setq nlista (length lista))
)
(defun inivar ()
	(setq os (getvar "osmode"))
	(setq capact (getvar "clayer"))
	(setvar "osmode" 0)
	(command "_elev" 0 0)
	(command "_ucs" "_w")
	(setvar "ucsfollow" 0)
)
(defun finvar ()
	(setvar "osmode" os)
	(setvar "clayer" capact)
)
(defun creacapa ()
	(command "_-layer" "_new" nomcap "")
	(command "_-layer" "_color" colorcap nomcap "")
	(command "_-layer" "_lweight" (/ grosorcap 100) nomcap "")
)
(defun vertices ()
	(setq u 0)
	(setq num (length lista))
	(setq lisptos nil)
	(setq lisptosx nil)
	(setq lisptosy nil)
	(repeat num
		(setq elem (nth u lista))
		(if (= (car elem) 10) 
			(progn
				(setq lisptos (cons (cdr elem) lisptos))
				(setq lisptosx (cons (cadr elem) lisptosx))
				(setq lisptosy (cons (caddr elem) lisptosy))
			)
		)
		(if (= (car elem) 38) (setq posi (cdr (assoc 38 lista))))
		(setq u (+ u 1))
	)
	(setq lisptos (reverse lisptos))
)
(defun copiafich ()
	(setq fich1 (open dato1 "r"))
	(setq fich2 (open dato2 "w"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich1)) 
		(if lin (write-line lin fich2))
	)
	(close fich2)
	(close fich1)
)
(defun ampliafich ()
	(setq fich1 (open dato1 "r"))
	(setq fich2 (open dato2 "a"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich1)) 
		(if lin (write-line lin fich2))
	)
	(close fich2)
	(close fich1)
)
(defun fichtipo2d3d ()
	(setq dato1 (strcat ruta "/2d3d_tipo.txt"))
	(setq dato2 (strcat dir nombre1 "_2d3d.txt"))
	(copiafich)
)
(defun fichpuerta2d3d ()
	(setq dato1 (strcat ruta "/2d3d_puerta.txt"))
	(setq dato2 (strcat dir nombre1 "_2d3d.txt"))
	(copiafich)
)
(defun comobloque ()
	(setq ctrl (tblsearch "block" nombre))
;	(if ctrl (command "_insert" nombre p3 fx fy p7) (command "_insert" fich p3 fx fy p7))
	(if ctrl (command "_insert" nombre) (command "_insert" fich))
)
(defun buscasolidos ()
	(setq ctrl1 nil ctrl2 nil ctrl3 nil)
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq ctrl1 (wcmatch nomcap "*|*"))
	(setq ctrl2 (ssget "x" (list (cons 0 "3dsolid") (cons 8 nomcap))))
	(setq ctrl3 (ssget "x" (list (cons 0 "insert") (cons 8 nomcap))))
	(if (and (= ctrl1 nil) (or ctrl2 ctrl3))
		(setq lista (cons nomcap lista))
	)
)
;;convierte lineas en polilineas de las capas instalaciones
(defun pasalinaplin ()
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(command "_pedit" (ssname conj n) "" "")
		(setq n (+ n 1))
	)
)
(defun c:lincapainspol ()
	(setq conj (ssget "x" (list (cons 0 "line") (cons 8 "i_font"))))
	(if conj (pasalinaplin))
	(setq conj (ssget "x" (list (cons 0 "line") (cons 8 "i_elec"))))
	(if conj (pasalinaplin))
	(setq conj (ssget "x" (list (cons 0 "line") (cons 8 "i_sanea"))))
	(if conj (pasalinaplin))
	(setq conj (ssget "x" (list (cons 0 "line") (cons 8 "i_vent"))))
	(if conj (pasalinaplin))
	(setq conj (ssget "x" (list (cons 0 "line") (cons 8 "i_telec"))))
	(if conj (pasalinaplin))
)
;;;;;;;;;;;;;;;;;;;;;;;;;fin de COMUNES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;CAPAS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;programas de manejo de capas;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;capano;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pide que se seleccione una entidad y apaga la capa en la que se encuentra esta
(defun c:capano ()
	(setvar "clayer" "0")
	(setq conj (ssget))
	(setq lis (entget (ssname conj 0)))
	(setq cap (cdr (assoc 8 lis)))
	(command "_-layer" "_off" cap "")
)
;;;;;;;;;;;;;;;;;;;;;;capauni;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pide que se seleccione una entidad y apaga todas las capas menos la de la entidad
(defun c:capauni ()
	(setq conj (ssget))
	(setq lis (entget (ssname conj 0)))
	(setq cap (cdr (assoc 8 lis)))
	(setvar "clayer" cap)
	(command "_-layer" "_off" "*" "" "")
)
;;;;;;;;;;;;;;;;;;;;;;capatot;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa todas las caspas incluso las descongela todas.
(defun c:capatot ()
	(command "_-layer" "_on" "*" "")
	(command "_-layer" "_thaw" "*" "")
)
;;programa similares a los de estados de capa.
;;capa2d
;;activa las capas 2d.
(defun c:capa2d ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capa2d.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
	(command "_shademode" "_2")
	(command "_plan" "_current")
	(command "_zoom" "_e")
	(command "_regen")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capafrente;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de frentes de forjado.
(defun c:capafrente ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capafrente.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capadintel;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de dinteles.
(defun c:capadintel ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capadintel.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capante;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de antepechos.
(defun c:capante ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capante.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capavierte;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de vierteaguas.
(defun c:capavierte ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capavierte.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capafalsote;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de falsostechos.
(defun c:capafalsote ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capafalsote.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capapavi;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de pavimentos.
(defun c:capapavi ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capapavi.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capasup;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de superficies
(defun c:capasup ()
	(setvar "clayer" "0")
	(setq ctrl (tblsearch "layer" "sutil"))
	(if (= ctrl nil) (setq nomcap "sutil" colorcap 206 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capasup.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(setvar "clayer" "sutil")
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capains;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de instalaciones
(defun c:capains ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capains.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capasomb;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa las capas de sombreado
(defun c:capasomb ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capasomb.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capacong;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;congela las capas de instalaciones
(defun c:capacong ()
	(command "_-layer" "_freeze" "i_*" "")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;capa3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa solo las capas 3d
(defun c:capa3d ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capa3d.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
	(command "_vpoint" (list -1 -1 1))
	(command "zoom" "_e")
	(command "_shademode" "_hidden")
;;	(setvar "perspective" 1)
;;	(setq conj (ssget "x" (list (cons 0 "lwpolyline"))))
;;	(command "HIDEOBJECTS" conj "")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;capacot;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;activa solo las capas de cotas y de carpinteria
(defun c:capacot ()
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(setq fich (open (strcat ruta "/capas/capacot.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if lin (command "_-layer" "_on" lin ""))
	)
	(close fich)
)
;;;;;;;;;;;;;;fin de programas para gestionar capas;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;2d3d comienzo;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;subprograma de levantamiento de bloques;;;;;;;;;;;;;;;;;;
;para sacar datos de carpinterias a la hora de descontar hueco
(defun inserenregion ()
	(setq lista2 (entget (ssname conj2 0)))
	(setq cap (cdr (assoc 8 lista2)))
	(setvar "clayer" cap)
	(setq p0a (list (car p0) (cadr p0) (+ alto cota)))
	(setq p0b (list (car p0) (cadr p0) cota))
	(setq p1a (list (car p1) (cadr p1) (+ alto cota)))
	(setq p1b (list (car p1) (cadr p1) cota))
	(command "_3dpoly" p0b p0a p1a p1b "close")
	(command "_region" (entlast) "")
	(command "_subtract" conj2 "" (entlast) "")
;	(command "_region" p2 p3 "")
;	(command "_subtract" conj2 "" (entlast) "")
)
(defun inserensolido ()
	(setq lista2 (entget (ssname conj2 0)))
	(setq cap (cdr (assoc 8 lista2)))
	(setvar "clayer" cap)
	(command "_pline" p0 p2 p3 p1 "close")
	(command "_extrude" (entlast) "" alto)
	(command "_move" (entlast) "" (list 0 0 0) (list 0 0 cota))
	(command "_subtract" conj2 "" (entlast) "")
)
(defun haydatoscarp ()
	(setq fichdatcarp (open (strcat ruta "/bloques/" subdir cap "/" nbl ".txt") "r"))
	(setq largo (read-line fichdatcarp))
	(setq alto (read-line fichdatcarp))
	(setq cota (read-line fichdatcarp))
	(setq largo (atof largo))
	(setq alto (atof alto))
	(setq cota (atof cota))
	(close fichdatcarp)
	(setq p1 (polar p0 ang (* fx largo)))
	(setq p2 (polar p0 (+ ang (/ pi 2)) (* fy largo)))
	(setq p3 (polar p2 ang (* fx largo)))
	(setq conj2 (ssget "_f" (list p0 p3) (list (cons 0 "3dsolid"))))
	(if conj2 (inserensolido))
	(setq conj2 (ssget "_f" (list p0 p3) (list (cons 0 "region"))))
	(if conj2 (inserenregion))
)
(defun nohaydatoscarp ()
	(setq ruta2 (strcat dir nbl ".txt"))
	(setq ctrl (findfile ruta2))
	(if ctrl (haydatoscarp))
)
(defun restamurocarp ()
	(setq ruta1 (strcat ruta "/bloques/" subdir cap "/" nbl ".txt"))
	(setq ctrl (findfile ruta1))
	(if ctrl (haydatoscarp) (nohaydatoscarp))
)
(defun levantablq ()
	(command "_-insert" (strcat nbl "=" ruta1) p0 "x" fx "y" fy 1 ang)
)
(defun nolevantablq ()
	(setq ruta1 (strcat dir nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(if ctrl (levantablq))
)
(defun 2d3dbloques ()
	(setq nconj (sslength conj))
	(setq n 0)
	(setq dir (getvar "dwgprefix"))
	(repeat nconj
		(setq ctrl nil)
		(setq lista (entget (ssname conj n)))
		(setq nbl (cdr (assoc 2 lista)))
		(setq cap (cdr (assoc 8 lista)))
		(setq p0 (cdr (assoc 10 lista)))
		(setq ang (cdr (assoc 50 lista)))
		(setq ang (/ (* 180 ang) pi))
		(setq fx (cdr (assoc 41 lista)))
		(setq fy (cdr (assoc 42 lista)))
		(setq ruta1 (strcat ruta "/bloques/" subdir cap "/" nbl ".dwg"))
		(setq ctrl (findfile ruta1))
		(setvar "clayer" cap)
		(if ctrl (command "_erase" (ssname conj n) ""))
		(if ctrl (levantablq) (nolevantablq))
		(if ctrl (restamurocarp))
		(setq n (+ n 1))
	)
)
;;;;;;;;;;;;;;;;;;;subprograma de levantamiento de circulos;;;;;;;;;;;;;;;;;;
(defun 2d3dcirculo ()
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq cap (cdr (assoc 8 lista)))
		(setq p nil z nil h nil)
		(sacadatos)
		(if (and (= p 0.0) (> h 0.0)) (polestrus))
		(setq n (+ n 1))
	)
)
;;;;;;;;;;;;;;;;;;;subprograma de levantamiento de polilineas;;;;;;;;;;;;;;;;;;
(defun polestrus ()
	(command "_copy" (ssname conj n) "" (list 0 0 0) (list 0 0 z))
	(setvar "clayer" cap3d)
	(command "_extrude" (entlast) "" h)
)
(defun estrusbajoplano ()
	(vertices)
	(setq pen (/ p 100))
	(setq listeje (entget (ssname conj2 0)))
	(setq p1e (cdr (assoc 10 listeje)))
	(setq p2e (cdr (assoc 11 listeje)))
	(setq ang (angle p1e p2e))
	(setq lispol1 nil)
	(setq lispol2 nil)
	(setq u 0)
	(setq num (length lisptos))
	(repeat num
		(setq p0 (nth u lisptos))
		(setq p0b (list (car p0) (cadr p0) z))
		(setq lispol1 (cons p0b lispol1))
		(setq p1 (polar p0 (+ ang (/ pi 2)) 1))
		(setq p0p (inters p1e p2e p0 p1 nil))
		(setq dis (distance p0 p0p))
		(setq alt (* dis pen))
		(setq p0a (list (car p0) (cadr p0) (+ alt)))
		(setq lispol2 (cons p0a lispol2))
		(setq u (+ u 1))
	)
	(setvar "clayer" cap3d)
	(command "_3dpoly" lispol1 "_c")
	(setq ent1 (entlast))
	(command "_3dpoly" lispol2 "_c")
	(setq ent2 (entlast))
	(command "_loft" ent1 ent2 "" "")
)
(defun estrusincli ()
	(vertices)
	(setq pen (/ p 100))
	(setq listeje (entget (ssname conj2 0)))
	(setq p1e (cdr (assoc 10 listeje)))
	(setq p2e (cdr (assoc 11 listeje)))
	(setq ang (angle p1e p2e))
	(setq lispol1 nil)
	(setq lispol2 nil)
	(setq u 0)
	(setq num (length lisptos))
	(repeat num
		(setq p0 (nth u lisptos))
		(setq p1 (polar p0 (+ ang (/ pi 2)) 1))
		(setq p0p (inters p1e p2e p0 p1 nil))
		(setq dis (distance p0 p0p))
		(setq alt (* dis pen))
		(setq p0a (list (car p0) (cadr p0) (+ alt z)))
		(setq lispol2 (cons p0a lispol2))
		(setq p0b (list (car p0) (cadr p0) (- (caddr p0a) h)))
		(setq lispol1 (cons p0b lispol1))
		(setq u (+ u 1))
	)
	(setvar "clayer" cap3d)
	(command "_3dpoly" lispol1 "_c")
	(setq ent1 (entlast))
	(command "_3dpoly" lispol2 "_c")
	(setq ent2 (entlast))
	(command "_loft" ent1 ent2 "" "")
)
(defun polestrusincli ()
	(setq capeje (strcat cap "-eje"))
	(setq conj2 nil)
	(setq conj2 (ssget "x" (list (cons 0 "line") (cons 8 capeje))))
	(if (and conj2 (= h 0.0)) (estrusbajoplano))
	(if (and conj2 (> h 0.0)) (estrusincli))
)
(defun 2d3dplin ()
	(setq cerrada (cdr (assoc 70 lista)))
	(if (and (= cerrada 1) (= p 0) (> h 0)) (polestrus))
)
(defun 2d3dplinincli ()
	(setq cerrada (cdr (assoc 70 lista)))
	(if (and (= cerrada 1) (> p 0)) (polestrusincli))
)
;;;;;;;;;;;;;;;;;;;fin del subprograma de levantamiento de polilineas;;;;;;;;;;;;;
(defun leedatos ()
	(setq p (read-line fich))
	(setq z (read-line fich))
	(setq h (read-line fich))
	(setq p (atof p))
	(setq z (atof z))
	(setq h (atof h))
)
(defun sacarmaterialcapa ()
; (vl-load-com)
  (setq acadObj (vlax-get-acad-object))   ;; Obtener el objeto de AutoCAD
  (setq doc (vlax-get acadObj 'ActiveDocument))  ;; Obtener el documento activo
  (setq layerTable (vla-get-Layers doc))  ;; Obtener la tabla de capas
	(setq layerObj (vla-item layerTable cap));; Obtener el objeto de la capa
	(setq material (vlax-get layerObj 'Material));; Intentar obtener la propiedad de material de la capa
)
(defun creacapa3d ()
	(setq cap3d (strcat "3d-" cap))
	(setq listacapact (tblsearch "layer" cap))
	(sacarmaterialcapa)
	(setq colorcapact (cdr (assoc 62 listacapact)))
	(setq ctrl (tblsearch "layer" cap3d))
	(if (= ctrl nil) (command "_-layer" "_new" cap3d ""))
	(if (= ctrl nil) (command "_-layer" "_color" colorcapact cap3d ""))
	(if (= ctrl nil) (command "_-layer" "_material" material cap3d ""))
)
(defun sacadatos ()
	(if (= (wcmatch cap "*3d*") nil) (creacapa3d) (setq cap3d cap))
	(setq fich (open (strcat nombre "_2d3d.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if (= lin cap3d) (leedatos))
	)
	(close fich)
)
(defun procesapolis ()
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq cap (cdr (assoc 8 lista)))
		(setq p nil z nil h nil)
		(sacadatos)
		(if (and (= p 0.0) (> h 0.0)) (2d3dplin))
		(if (and (/= p 0.0) (/= h nil)) (2d3dplinincli))
		(setq n (+ n 1))
	)
)
;;;;;;;;;;;;;;;;;;;subprograma de levantamiento de lineas;;;;;;;;;;;;;;;;;;
(defun 2d3dlin ()
	(setq lista (entget (ssname conj n)))
	(setq p1 (cdr (assoc 10 lista)))
	(setq p2 (cdr (assoc 11 lista)))
	(setq p1b (list (car p1) (cadr p1) z))
	(setq p2b (list (car p2) (cadr p2) z))
	(setq p1a (list (car p1) (cadr p1) (+ z h)))
	(setq p2a (list (car p2) (cadr p2) (+ z h)))
	(setvar "clayer" cap3d)
	(command "_3dpoly" p1b p1a p2a p2b p1b "")
	(command "_region" (entlast) "")
)
(defun linbajoplano ()
	(setq lista (entget (ssname conj n)))
	(setq p1 (cdr (assoc 10 lista)))
	(setq p2 (cdr (assoc 11 lista)))
	(setq pen (/ p 100))
	(setq listeje (entget (ssname conj2 0)))
	(setq p1e (cdr (assoc 10 listeje)))
	(setq p2e (cdr (assoc 11 listeje)))
	(setq ang (angle p1e p2e))
	(setq p3 (polar p1 (+ ang (/ pi 2)) 1))
	(setq p1p (inters p1 p3 p1e p2e nil))
	(setq dis (distance p1 p1p))
	(setq altp1 (* dis pen))
	(setq p4 (polar p2 (+ ang (/ pi 2)) 1))
	(setq p2p (inters p2 p4 p1e p2e nil))
	(setq dis (distance p2 p2p))
	(setq altp2 (* dis pen))
	(setq p1b (list (car p1) (cadr p1) z))
	(setq p2b (list (car p2) (cadr p2) z))
	(setq p1a (list (car p1) (cadr p1) (+ altp1)))
	(setq p2a (list (car p2) (cadr p2) (+ altp2)))
	(setvar "clayer" cap3d)
	(command "_3dpoly" p1b p1a p2a p2b p1b "")
	(command "_region" (entlast) "")
)
(defun linincli ()
	(setq lista (entget (ssname conj n)))
	(setq p1 (cdr (assoc 10 lista)))
	(setq p2 (cdr (assoc 11 lista)))
	(setq pen (/ p 100))
	(setq listeje (entget (ssname conj2 0)))
	(setq p1e (cdr (assoc 10 listeje)))
	(setq p2e (cdr (assoc 11 listeje)))
	(setq ang (angle p1e p2e))
	(setq p3 (polar p1 (+ ang (/ pi 2)) 1))
	(setq p1p (inters p1 p3 p1e p2e nil))
	(setq dis (distance p1 p1p))
	(setq altp1 (* dis pen))
	(setq p4 (polar p2 (+ ang (/ pi 2)) 1))
	(setq p2p (inters p2 p4 p1e p2e nil))
	(setq dis (distance p2 p2p))
	(setq altp2 (* dis pen))
	(setq p1a (list (car p1) (cadr p1) (+ z altp1)))
	(setq p2a (list (car p2) (cadr p2) (+ z altp2)))
	(setq p1b (list (car p1) (cadr p1) (- (caddr p1a) h)))
	(setq p2b (list (car p2) (cadr p2) (- (caddr p2a) h)))
	(setvar "clayer" cap3d)
	(command "_3dpoly" p1b p1a p2a p2b p1b "")
	(command "_region" (entlast) "")
)
(defun 2d3dlinincli ()
	(setq capeje (strcat cap "-eje"))
	(setq conj2 nil)
	(setq conj2 (ssget "x" (list (cons 0 "line") (cons 8 capeje))))
	(if (and conj2 (= h 0.0)) (linbajoplano))
	(if (and conj2 (> h 0.0)) (linincli))
)
(defun procesalineas ()
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq cap (cdr (assoc 8 lista)))
		(setq p nil z nil h nil)
		(sacadatos)
		(if (and (= p 0.0) (> h 0.0)) (2d3dlin))
		(if (and (/= p 0.0) (/= h nil)) (2d3dlinincli))
		(setq n (+ n 1))
	)
)
(defun nlevanta3d ()
	(alert (strcat "No existe el fichero de levantamiento " nombre "_2d3d.txt, lo voy a crear"))
	(setq ctrl (wcmatch nombre1 "*[x]*"))
	(if ctrl (fichpuerta2d3d) (fichtipo2d3d))
	(alert (strcat "Se ha creado un fichero de levantamiento " nombre "_2d3d.txt en la ruta del fichero dwg. Por favor, vuelva a ejecutar 2d3d"))
)
;;(defun descuentahuecoshor ()
;;	(setq conj1 (ssget "x" (list (cons 0 "3dsolid") (cons 8 tipohuecohor1))))
;;	(setq conj2 (ssget "x" (list (cons 0 "3dsolid") (cons 8 tipohuecohor2))))
;;	(if (and conj1 conj2) (command "_subtract" conj1 "" conj2 ""))
;;)
(defun levanta3d ()
	(inivar)
;;hacemos que levante polilineas
	(command "_-layer" "_on" "*" "")
	(setq conj (ssget "x" (list (cons 0 "lwpolyline"))))
	(if conj (procesapolis))
;;tambien hacemos que levante las entidades de tipo circulo.
	(setq conj (ssget "x" (list (cons 0 "circle"))))
	(if conj (2d3dcirculo))
;;por supuesto que levante los bloques. En realidad lo que hace es sustituir el bloque en 2d por el de 3d.
	(setq conj (ssget "x" (list (cons 0 "insert"))))
	(if conj (setq subdir "3d-"))
	(if conj (2d3dbloques))
;;por ultimo hacemos que levante las lineas.
;;en el fichero de levantamiento. Las lineas las levanta como regiones.
	(setq conj (ssget "x" (list (cons 0 "line"))))
	(if conj (procesalineas))
;;activa las capas 3d y el estilo visual shademode
;;luego hace un zoom extension
	(c:capa3d)
	(command "_vpoint" (list -1 -1 1))
	(command "zoom" "_e")
	(setvar "perspective" 1)
	(command "zoom" "_e")
	(command "_shademode" "_gouraud")
	(finvar)
)
(defun inicia2d3d ()
	(nombrefich)
	(setq ctrl1 nil ctrl2 nil ctrl3 nil)
	(setq ctrl1 (ssget "x" (list (cons 0 "3dsolid"))))
	(setq ctrl2 (wcmatch nombre1 "*3d*"))
	(setq ctrl3 (findfile (strcat nombre "_2d3d.txt")))
	(if ctrl2 (alert "no puedo levantar un fichero que contenga 3d en el nombre"))
	(if ctrl1 (alert "no puedo levantar un fichero que contenga solidos3d"))
	(if (and (= ctrl1 nil) (= ctrl2 nil) (= ctrl3 nil)) (nlevanta3d))
	(if (and (= ctrl1 nil) (= ctrl2 nil) ctrl3) (levanta3d))
)
(defun c:2d3d ()
	(setq guardaprev (getvar "dwgtitled"))
	(if (= guardaprev 0) (alert "No se ha guardado el dibujo todavia en ningun directorio") (inicia2d3d))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;fin de 2d3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;3d2d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;es el programa contrario al anterior: baja a 2d una maqueta 3d
;;fundamentalmente elimina todos los solidos y caras 3d
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:3d2d ()
	(inivar)
	(command "_shademode" "_2")
	(setq conj (ssget "x" (list (cons 0 "3dsolid"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "3dface"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "region"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "insert"))))
	(if conj (setq subdir "2d-"))
	(if conj (2d3dbloques))
	(command "_vpoint" (list 0 0 1))
	(command "zoom" "e")
	(command "_regen")
	(c:capa2d)
	(finvar)
)
;;;;;;;;;;;;;;;;;;fin del programa 3d2d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;2d3drampa;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;levanta un solido preguntando la recta base, la pendiente y los vertices;;
(defun consrampa ()
	(setq nlista (length listaptos1))
	(setq n 0)
	(setq listaptos2 nil)
	(repeat nlista
		(setq pto (nth n listaptos1))
		(setq p3 (polar pto (+ ang (/ pi 2)) 1))
		(setq p4 (inters p1 p2 pto p3 nil))
		(setq dis (distance pto p4))
		(setq h (* dis (/ pen 100)))
		(setq pto (list (car pto) (cadr pto) h))
		(setq listaptos2 (cons pto listaptos2))
		(setq n (+ n 1))
	)
	(command "_3dpoly" p1 listaptos2 p2 p1 "")
	(command "_extrude" (entlast) "" "_d" (list 0 0 0) (list 0 0 esp))
	(command "_move" (entlast) "" (list 0 0 0) (list 0 0 pos))
)
(defun c:2d3drampa ()
	(inivar)
	(prompt "selecciona recta base:")
	(terpri)
	(setq conj (ssget))
	(setq lista (entget (ssname conj 0)))
	(setq p1 (cdr (assoc 10 lista)))
	(setq p2 (cdr (assoc 11 lista)))
	(setq ang (angle p1 p2))
	(setq pen (getreal "pendiente(10%):"))
	(if (= pen nil) (setq pen 10.0))
	(setq esp (getreal "espesor(0.1)"))
	(if (= esp nil) (setq esp -0.1))
	(setq pos (getreal "posicion(0.0):"))
	(if (= pos nil) (setq pos 0.0))
	(setq lista (entget (ssname conj 0)))
	(setq listaptos1 nil)
	(setvar "osmode" 32)
	(setq pto t)
	(while pto
		(setq pto (getpoint "punto:"))
		(if pto (setq listaptos1 (cons pto listaptos1)))
	)
	(setvar "osmode" 0)
	(if listaptos1 (consrampa) (alert "no se ha designado ningun punto"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;edita3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;sirve para editar con el notepad el fichero de levantamiento 3d asociado al dwg
;;en linux no funciona por lo que meto un alert para que de un mensaje que diga que el fichero
;;se puede editar con cualquier editor de texto.
(defun muestradatos3d ()
;;	(alert (strcat "El fichero de levantamiento se encuentra en la carpeta " (strcat nombre "_2d3d.txt") " Para editarlo abrelo con cualquier editor de texto."))
;;para windows
	(command "shell" (strcat "notepad " nombre "_2d3d.txt"))
;;para linux
;;	(command "shell" (strcat "less " nombre "_2d3d.txt"))
)
(defun c:edita3d ()
	(nombrefich)
	(setq ctrl nil)
	(setq ctrl (findfile (strcat nombre "_2d3d.txt")))
	(if ctrl (muestradatos3d) (alert (strcat "no existe el fichero de levantamiento " nombre "_2d3d.txt")))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;ordena3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;sirve para ordenar alfabeticamente el fichero de levantamiento 3d;;;;;;;;;;;;;
(defun apuntaelem3d ()
	(write-line lin1 fich1)
	(setq lin2 (read-line fich2))
	(write-line lin2 fich1)
	(setq lin3 (read-line fich2))
	(write-line lin3 fich1)
	(setq lin4 (read-line fich2))
	(write-line lin4 fich1)
)
(defun elemlista3d ()
	(setq fich2 (open (strcat nombre "_2d3d.txt") "r"))
	(setq lin1 t)
	(while lin1
		(setq lin1 (read-line fich2)) 
		(if (= lin1 elem) (apuntaelem3d))
	)
	(close fich2)
)
(defun sacalista3d ()
	(setq fich (open (strcat nombre "_2d3d.txt") "r"))
	(setq lista nil)
	(setq lin t)
	(while lin
		(setq lin (read-line fich)) 
		(if lin (setq lista (cons lin lista)))
		(if lin (read-line fich))
		(if lin (read-line fich))
		(if lin (read-line fich))
	)
	(close fich)
	(setq lista (acad_strlsort lista))
	(setq fich1 (open (strcat nombre "_temp.txt") "w"))
	(setq nlista (length lista))
	(setq n 0)
	(repeat nlista
		(setq elem (nth n lista))
		(elemlista3d)
		(setq n (+ n 1))
	)
	(close fich1)
)
(defun organiza3d ()
	(sacalista3d)
	(setq dato1 (strcat nombre "_temp.txt"))
	(setq dato2 (strcat nombre "_2d3d.txt"))
	(copiafich)
	(command "shell" (strcat "del " nombre "_temp.txt"))
	(alert (strcat "se ha ordenado el fichero " nombre "_2d3d.txt"))
)
(defun c:ordena3d ()
	(nombrefich)
	(setq ctrl nil)
	(setq ctrl (findfile (strcat nombre "_2d3d.txt")))
	(if ctrl (organiza3d) (alert (strcat "no existe el fichero de levantamiento " nombre "_2d3d.txt")))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;limpiafichero3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este solo se puede usar con la maqueta levantada.
;;toma cada uno de los datos del fichero de levantamiento _3d3d y comprueba si la capa tiene entidades de tipo solido
;;si las tiene la deja sino la borra de _2d3d
(defun anota3dfiltrado ()
	(write-line lin1 fich1)
	(write-line lin2 fich1)
	(write-line lin3 fich1)
	(write-line lin4 fich1)
)
(defun capasi3d ()
	(setq ctrl1 nil ctrl2 nil ctrl3 nil ctrl4 nil)
	(setq ctrl1 (wcmatch lin1 "*|*"))
	(setq ctrl2 (ssget "x" (list (cons 0 "3dsolid") (cons 8 lin1))))
	(if (and (= ctrl1 nil) ctrl2) (anota3dfiltrado))
)
(defun filtraelem3d ()
	(setq lin2 (read-line fich2))
	(setq lin3 (read-line fich2))
	(setq lin4 (read-line fich2))
	(if (tblsearch "layer" lin1) (capasi3d))
)
(defun filtrafich3d ()
	(setq fich1 (open (strcat nombre "_temp.txt") "w"))
	(setq fich2 (open (strcat nombre "_2d3d.txt") "r"))
	(setq lin1 t)
	(while lin1
		(setq lin1 (read-line fich2)) 
		(if lin1 (filtraelem3d))
	)
	(close fich2)
	(close fich1)
	(setq dato1 (strcat nombre "_temp.txt"))
	(setq dato2 (strcat nombre "_2d3d.txt"))
	(copiafich)
	(command "shell" (strcat "del " nombre "_temp.txt"))
	(alert (strcat "se ha filtrado el fichero " nombre "_2d3d.txt"))
)
(defun c:limpiafich3d ()
	(nombrefich)
	(setq ctrl1 nil ctrl2 nil)
	(setq ctrl1 (findfile (strcat nombre "_2d3d.txt")))
	(setq ctrl2 (ssget "x" (list (cons 0 "3dsolid"))))
	(if (and ctrl1 ctrl2) (filtrafich3d) (alert (strcat "no existe el fichero de levantamiento " nombre "_2d3d.txt o no hay solidos")))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PROGRAMAS DE BLOQUES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;creabloque2d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:creabloque2d ()
	(command "_-layer" "_on" "*" "")
	(prompt "selecciona entidades:")
	(setq conj (ssget))
	(setq nomblq (getstring "nombre del bloque:"))
	(command "_move" conj "" p0 (list 0 0 0))
	(command "_zoom" "_ce" (list 0.5 0.5 0) "")
	(command "_wblock" nomblq "" (list 0 0 0) conj "")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;editablq2d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun noabrebloque2d ()
	(setq ruta1 (strcat dir nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(if ctrl (command "_open" ruta1) (alert (strcat "no se ha encontrado el bloque" nbl "en la ruta ")))
)
(defun abrebloque2d ()
	(setq ctrl nil)
	(setq cap (cdr (assoc 8 lista)))
	(setq nbl (cdr (assoc 2 lista)))
	(setq ruta1 (strcat ruta "/bloques/2d-" cap "/" nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(if ctrl (command "_open" ruta1) (noabrebloque2d))
)
(defun c:editablq2d ()
	(setq dir (getvar "dwgprefix"))
	(prompt "Selecciona bloque a editar:")
	(setq conj (ssget))
	(setq lista (entget (ssname conj 0)))
	(setq tipoent (cdr (assoc 0 lista)))
	(if (= tipoent "INSERT") (abrebloque2d) (alert "No se ha seleccionado un bloque"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;editablq3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun noabrebloque3d ()
	(setq ruta1 (strcat dir nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(if ctrl (command "_open" ruta1) (alert (strcat "no se ha encontrado el bloque" nbl "en la ruta ")))
)
(defun abrebloque3d ()
	(setq ctrl nil)
	(setq cap (cdr (assoc 8 lista)))
	(setq nbl (cdr (assoc 2 lista)))
	(setq ruta1 (strcat ruta "/bloques/3d-" cap "/" nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(if ctrl (command "_open" ruta1) (noabrebloque3d))
)
(defun c:editablq3d ()
	(setq dir (getvar "dwgprefix"))
	(prompt "Selecciona bloque a editar:")
	(setq conj (ssget))
	(setq lista (entget (ssname conj 0)))
	(setq tipoent (cdr (assoc 0 lista)))
	(if (= tipoent "INSERT") (abrebloque3d) (alert "No se ha seleccionado un bloque"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;actualizablq;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;actualiza los bloques de puertas, ventanas, escaleras y muebles.
(defun renuevablq ()
	(command "_-insert" (strcat nbl "=" ruta1) p0 "x" fx "y" fy 1 ang)
)
(defun norenuevablq ()
	(setq ruta1 (strcat dir nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(if ctrl (renuevablq) (alert (strcat "No se ha encontrado el bloque " nbl)))
)
(defun sustblq ()
	(setq dir (getvar "dwgprefix"))
	(setq ctrl nil)
	(setq lista (entget (ssname conj 0)))
	(setq nbl (cdr (assoc 2 lista)))
	(setq cap (cdr (assoc 8 lista)))
	(setq p0 (cdr (assoc 10 lista)))
	(setq ang (cdr (assoc 50 lista)))
	(setq ang (/ (* 180 ang) pi))
	(setq fx (cdr (assoc 41 lista)))
	(setq fy (cdr (assoc 42 lista)))
	(setq ruta1 (strcat ruta "/bloques/2d-" cap "/" nbl ".dwg"))
	(setq ctrl (findfile ruta1))
	(setvar "clayer" cap)
	(if ctrl (command "_erase" (ssname conj 0) ""))
	(if ctrl (renuevablq) (norenuevablq))
)
(defun c:actualizablq ()
	(inivar)
	(prompt "selecciona bloque a actualizar:")
	(setq conj (ssget))
	(if conj (sustblq))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqpuerbat;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa para insertar puertas.
(defun revisacapapuer ()
	(setq ctrl (tblsearch "layer" "puertas"))
	(if (= ctrl nil) (setq nomcap "puertas" colorcap 8 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "puertas")
	(setq dir (strcat ruta "/bloques/2d-puertas/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(setq fich (strcat dir nombre ".dwg"))
	(comobloque)
)
(defun c:blqpuerbat ()
	(c:capa2d)
	(setq fich (getfiled "elige puerta a insertar" (strcat ruta "/bloques/2d-puertas/") "dwg" 8))
	(if fich (revisacapapuer) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqventbat;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa para insertar ventanas.
(defun revisacapaven ()
	(setq ctrl (tblsearch "layer" "ventanas"))
	(if (= ctrl nil) (setq nomcap "ventanas" colorcap 8 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "ventanas")
	(setq dir (strcat ruta "/bloques/2d-ventanas/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(setq fich (strcat dir nombre ".dwg"))
	(comobloque)
)
(defun c:blqventbat ()
	(c:capa2d)
	(setq fich (getfiled "elige ventana a insertar" (strcat ruta "/bloques/2d-ventanas/") "dwg" 8))
	(if fich (revisacapaven) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqescal;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapescal ()
	(setq ctrl (tblsearch "layer" "escaleras"))
	(if (= ctrl nil) (setq nomcap "escaleras" colorcap 8 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "escaleras")
	(setq dir (strcat ruta "/bloques/2d-escaleras/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(setq fich (strcat dir nombre ".dwg"))
	(comobloque)
)
(defun c:blqescal ()
	(c:capa2d)
	(setq fich (getfiled "elige escalera a insertar" (strcat ruta "/bloques/2d-escaleras/") "dwg" 8))
	(if fich (revisacapescal) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqpilar;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacappilar ()
	(setq ctrl (tblsearch "layer" "pilares"))
	(if (= ctrl nil) (setq nomcap "pilares" colorcap 8 grosorcap 80.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "pilares")
	(setq dir (strcat ruta "/bloques/2d-pilares/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(setq fich (strcat dir nombre ".dwg"))
	(comobloque)
)
(defun c:blqpilar ()
	(c:capa2d)
	(setq fich (getfiled "elige el pilar a insertar" (strcat ruta "/bloques/2d-pilares/") "dwg" 8))
	(if fich (revisacappilar) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqmueble;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapmueb ()
	(setq ctrl (tblsearch "layer" "muebles"))
	(if (= ctrl nil) (setq nomcap "muebles" colorcap 8 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "muebles")
	(setq dir (strcat ruta "/bloques/2d-muebles/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqmueble ()
	(c:capa2d)
	(setq fich (getfiled "mueble" (strcat ruta "/bloques/2d-muebles/") "dwg" 8))
	(if fich (revisacapmueb) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqformat;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapform ()
	(setvar "clayer" "0")
	(setq dir (strcat ruta "/bloques/formato/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqformat ()
	(c:capatot)
	(setq fich (getfiled "formato" (strcat ruta "/bloques/formato/") "dwg" 8))
	(if fich (revisacapform) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqielec;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapaielec ()
	(setq ctrl (tblsearch "layer" "i_elec"))
	(if (= ctrl nil) (setq nomcap "i_elec" colorcap 20 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "i_elec")
	(setq dir (strcat ruta "/bloques/2d-i_elec/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqielec ()
	(c:capains)
	(setq fich (getfiled "i_elec" (strcat ruta "/bloques/2d-i_elec/") "dwg" 8))
	(if fich (revisacapaielec) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqifont;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapaifont ()
	(setq ctrl (tblsearch "layer" "i_font"))
	(if (= ctrl nil) (setq nomcap "i_font" colorcap 144 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "i_font")
	(setq dir (strcat ruta "/bloques/2d-i_font/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqifont ()
	(c:capains)
	(setq fich (getfiled "i_font" (strcat ruta "/bloques/2d-i_font/") "dwg" 8))
	(if fich (revisacapaifont) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqivent;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapaivent ()
	(setq ctrl (tblsearch "layer" "i_vent"))
	(if (= ctrl nil) (setq nomcap "i_vent" colorcap 8 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "i_vent")
	(setq dir (strcat ruta "/bloques/2d-i_vent/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqivent ()
	(c:capains)
	(setq fich (getfiled "i_vent" (strcat ruta "/bloques/2d-i_vent/") "dwg" 8))
	(if fich (revisacapaivent) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;i_sanea;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapaisanea ()
	(setq ctrl (tblsearch "layer" "i_sanea"))
	(if (= ctrl nil) (setq nomcap "i_sanea" colorcap 25 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "i_sanea")
	(setq dir (strcat ruta "/bloques/2d-i_sanea/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqisanea ()
	(c:capains)
	(setq fich (getfiled "i_sanea" (strcat ruta "/bloques/2d-i_sanea/") "dwg" 8))
	(if fich (revisacapaisanea) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;i_incen;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapaincen ()
	(setq ctrl (tblsearch "layer" "i_incen"))
	(if (= ctrl nil) (setq nomcap "i_incen" colorcap 214 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "i_incen")
	(setq dir (strcat ruta "/bloques/2d-i_incen/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqincen ()
	(c:capains)
	(setq fich (getfiled "i_calef" (strcat ruta "/bloques/2d-i_incen/") "dwg" 8))
	(if fich (revisacapaincen) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;i_calef;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapacalef ()
	(setq ctrl (tblsearch "layer" "i_calef"))
	(if (= ctrl nil) (setq nomcap "i_calef" colorcap 95 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "i_calef")
	(setq dir (strcat ruta "/bloques/2d-i_calef/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(comobloque)
)
(defun c:blqicalef ()
	(c:capains)
	(setq fich (getfiled "i_calef" (strcat ruta "/bloques/2d-i_calef/") "dwg" 8))
	(if fich (revisacapacalef) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;blqperfil;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun revisacapaperfil ()
	(setq ctrl (tblsearch "layer" "perfiles"))
	(if (= ctrl nil) (setq nomcap "perfiles" colorcap 8 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "perfiles")
	(setq dir (strcat ruta "/bloques/2d-perfiles/"))
	(setq nombre1 (substr fich (+ (strlen dir) 1)))
	(setq nombre (substr nombre1 1 (- (strlen nombre1) 4)))
	(setq fich (substr fich 1 (- (strlen fich) 4)))
	(setq fich (strcat fich ".dwg"))
	(comobloque)
)
(defun c:blqperfil ()
	(c:capa2d)
	(setq fich (getfiled "perfiles" (strcat ruta "/bloques/2d-perfiles/") "dwg" 8))
	(if fich (revisacapaperfil) (alert "no se ha seleccionado ningun fichero"))
)
;;;;;;;;;;;;;;;;;;;;;;capas en el planos;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;capref;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun operarefx ()
	(setq fich (open (strcat ruta "/capas/" fichtipo ".txt") "r"))
	(setq cap t)
	(while cap
		(setq cap (read-line fich))
		(setq col (read-line fich))
		(setq grosor (read-line fich))
		(if cap (command "_-layer" "_on" (strcat nomrefx "|" cap "*") ""))
		(if cap (command "_-layer" "_color" col (strcat nomrefx "|" cap "*") ""))
		(if cap (command "_-layer" "_lweight" grosor (strcat nomrefx "|" cap "*") ""))
	)
	(close fich)
)
(defun iniciacapref ()
	(command "lwdisplay" "1")
	(command "visretain" "1")
	(command "_-layer" "_off" "*|*" "")
	(setq n 0)
	(setq nrefx (sslength conj))
	(repeat nrefx
		(setq lisrefx (entget (ssname conj n)))
		(setq nomrefx (cdr (assoc 2 lisrefx)))
		(operarefx)
		(setq n (+ n 1))
	)
	(command "_regen")
)
(defun c:capref ()
	(inivar)
	(nombrefich)
	(setq tipofich (substr nombre1 4 3))
	(setq fichtipo (strcat "caprefx" tipofich))
	(setq ctrl (findfile (strcat ruta "/capas/" fichtipo ".txt")))
	(setq conj (ssget "x" (list (cons 8 "0") (cons 0 "INSERT"))))
	(if (and ctrl conj) (iniciacapref) (alert "No se ha encontrado ninguna referencia externa"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;superficies;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;suputil;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun tipomueble ()
	(setq nconj2 (sslength conj2))
	(setq m 0)
	(repeat nconj2
		(setq lisent2 (entget (ssname conj2 m)))
		(setq txtblq (cdr (assoc 2 lisent2)))
;;		(if txtblq (setq txtblq (strcase txtblq)))
;;		(if (= txtblq "cocina lugo") (setq txthab "cocina"))
		(if (wcmatch txtblq "*salon*") (setq txthab "salon-comedor"))
		(if (wcmatch txtblq "*dorm*") (setq txthab "dormitorio"))
		(if (wcmatch txtblq "*cocina*") (setq txthab "cocina"))
		(if (wcmatch txtblq "*sanit*") (setq txthab "aseo"))
		(if (wcmatch txtblq "*terraza*") (setq txthab "terraza"))
		(setq m (+ m 1))
	)
)
(defun tipopoli ()
	(setq nconj2 (sslength conj2))
	(setq m 0)
	(repeat nconj2
		(setq lisent2 (entget (ssname conj2 m)))
		(setq capa (cdr (assoc 8 lisent2)))
		(if (= capa "cubierta") (setq txthab "buardilla"))
		(if (= capa "albardilla") (setq txthab "terraza"))
		(if (= capa "vierte1") (setq txthab "terraza"))
		(if (= capa "pasamanos1") (setq txthab "terraza"))
		(setq m (+ m 1))
	)
)
(defun tipohab ()
	(setq lis (entget (ssname conj n)))
	(vertices_sup)
	(setq txthab "habitacion")
	(setq conj2 (ssget "_cp" lisptos (list (cons 0 "line") (cons 8 "plazas"))))
	(if conj2 (setq lis_ent2 (entget (ssname conj2 0))))
	(if conj2 (setq txthab "P-"))
;	(setq conj2 (ssget "_cp" lisptos (list (cons 0 "lwpolyline"))))
;	(if conj2 (tipopoli))
	(setq conj2 (ssget "_cp" lisptos (list (cons 0 "insert") (cons 8 "muebles*"))))
	(if conj2 (tipomueble))
)
(defun pon_textos_area ()
	(setq ar (rtos ar 2 2))
	(setq p1 (nth 0 lisptos))
	(setq p2 (nth 2 lisptos))
	(setq sumptosx (apply '+ lisptosx))
	(setq numptosx (length lisptosx))
	(setq sumptosy (apply '+ lisptosy))
	(setq numptosy (length lisptosy))
	(setq p0 (list (/ sumptosx numptosx) (/ sumptosy numptosy) 0))
	(setq p0b (list (car p0) (+ (* escal 1.5 0.15) (cadr p0)) 0))
	(c:capa2d)
	(setvar "clayer" "texto")
	(setvar "osmode" 0)
	(command "_text" p0 "" "0" (strcat ar "m2"))
	(setq textos (cons (entlast) textos))
	(tipohab)
	(setvar "clayer" "habitacion")
	(command "_text" p0b "" "0" txthab)
)
(defun area_pol_pavi ()
	(c:capa2d)
	(setq nlisptos (length lisptos))
	(command "_area" (nth 0 lisptos))
	(setq m 1)
	(repeat (- nlisptos 1)
		(command (nth m lisptos))
		(setq m (+ m 1))
	)
	(command "")
)
(defun vertices_sup ()
	(setq u 0)
	(setq num (length lis))
	(setq lisptos nil)
	(setq lisptosx nil)
	(setq lisptosy nil)
	(repeat num
		(setq elem (nth u lis))
		(if (= (car elem) 10) 
			(progn
				(setq lisptos (cons (cdr elem) lisptos))
				(setq lisptosx (cons (cadr elem) lisptosx))
				(setq lisptosy (cons (caddr elem) lisptosy))
			)
		)
		(setq u (+ u 1))
	)
	(setq lisptos (reverse lisptos))
)
(defun sup_pavi ()
	(setq escal nil)
;;	(setq escal (getreal "escala:"))
	(if (= escal nil) (setq escal 1.0))
	(setvar "textsize" (* escal 0.2))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lis (entget (ssname conj n)))
		(vertices_sup)
		(area_pol_pavi)
		(setq ar (getvar "area"))
		(if (> ar 0) (pon_textos_area))
		(setq n (+ n 1))
	)
)
(defun compruebahabita ()
	(setq ctrl (tblsearch "layer" "texto"))
	(if (= ctrl nil) (setq nomcap "texto" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setq ctrl (tblsearch "layer" "habitacion"))
	(if (= ctrl nil) (setq nomcap "habitacion" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "texto" "")
	(command "_-layer" "_on" "habitacion" "")
)
(defun iniciasutil ()
	(compruebahabita)
	(setq ctrl (tblsearch "style" "cursoedif"))
	(if ctrl (setvar "textstyle" "cursoedif"))
	(setq conj (ssget "x" (list (cons 8 "texto"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 8 "habitacion"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "lwpolyline") (cons 8 "sutil"))))
	(if conj (sup_pavi))
	(c:capa2d)
)
(defun c:suputil ()
	(inivar)
	(setq conj (ssget "x" (list (cons 0 "lwpolyline") (cons 8 "sutil"))))
	(if conj (iniciasutil) (alert "No se ha encontrado ninguna polilinea en la capa sutil"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;suputil1;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:suputil1 ()
	(inivar)
	(compruebahabita)
	(c:capasup)
	(prompt "Selecciona polilinea o polilineas en la capa sutil:")
	(setq conj (ssget))
	(if conj (sup_pavi))
	(c:capa2d)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;suputil1entre2;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;calcula la superficie util de una polilinea y la divide entre 2
(defun sup_pavi2 ()
	(setq escal nil)
;;	(setq escal (getreal "escala:"))
	(if (= escal nil) (setq escal 1.0))
	(setvar "textsize" (* escal 0.2))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lis (entget (ssname conj n)))
		(vertices_sup)
		(area_pol_pavi)
		(setq ar / ar 2)
		(if (> ar 0) (pon_textos_area))
		(setq n (+ n 1))
	)
)
(defun c:suputil1entre2 ()
	(inivar)
	(c:capasup)
	(compruebahabita)
	(prompt "Selecciona polilinea o polilineas en la capa sutil:")
	(setq conj (ssget))
	(if conj (sup_pavi2))
	(c:capa2d)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;cuadrosup;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;crea un fichero csv con los textos y las superficies de las habitaciones de la planta.
;;no pide polilinea porque se supone que solo hay una planta.
(defun suphabit ()
	(setq lista2 (entget (ssname conj2 0)))
	(setq txt2 (cdr (assoc 1 lista2)))
	(setq txt2num (atof txt2))
	(princ (strcat txt ";" (rtos txt2num 2 2) ";m2") fich)
	(write-line "" fich)
)
(defun rellenacuadro ()
	(command "_zoom" "e")
	(setq nconj (sslength conj))
	(setq n 0)
	(write-line "habitacion;superficie;unidades" fich)
	(write-line ";;" fich)
	(setq tot 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq txt (cdr (assoc 1 lista)))
		(setq p0 (cdr (assoc 10 lista)))
		(setq p1 (list (+ (car p0) 0.5) (- (cadr p0) 0.5) (caddr p0)))
		(setq conj2 (ssget "c" p0 p1 (list (cons 8 "texto"))))
		(if conj2 (suphabit))
		(setq tot (+ tot txt2num))
		(setq n (+ n 1))
	)
	(write-line ";;" fich)
	(write-line (strcat "TOTAL;" (rtos tot 2 2) ";") fich)
)
(defun c:cuadrosup ()
	(inivar)
	(c:capa2d)
	(nombrefich)
	(setq fich (open (strcat nombre "_sup.csv") "w"))
	(setq ctrl (tblsearch "layer" "texto"))
	(if (= ctrl nil) (setq nomcap "texto" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "texto" "")
	(setvar "textsize" 0.2)
	(setq conj (ssget "x" (list (cons 0 "text") (cons 8 "habitacion"))))
	(if conj (rellenacuadro) (alert "no se han encontrado textos en la capa habitacion"))
	(close fich)
	(if (> tot 0) (alert (strcat "Se ha creado un fichero llamado" nombre "_sup.csv " "en la carpeta del dibujo")))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;cuadrosupol;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pide que se seleccionen polilineas de superficie construida que contienen superficies utiles
;;el nombre interior en la capa textopiso es el que usa para identificar el grupo
;;el fichero csv que crea esta formado por el nombre de la planta y el nombre del grupo.
(defun procesasucons ()
	(setq nconj3 (sslength conj3))
	(setq m 0)
	(repeat nconj3
		(setq lista (entget (ssname conj3 m)))
		(setq cap (cdr (assoc 8 lista)))
		(write-line "" fich)
		(vertices)
		(setq conj (ssget "_cp" lisptos (list (cons 0 "text") (cons 8 "textopiso"))))
		(if conj (setq listxtpiso (entget (ssname conj 0))))
		(if conj (setq textopiso (cdr (assoc 1 listxtpiso))))
		(if conj (write-line (strcat "SUPERFICIES UTILES PISO: " textopiso) fich) (write-line "SUPERFICIES UTILES PISO DESCONOCIDO: " fich))
		(write-line "" fich)
		(setq conj (ssget "_cp" lisptos (list (cons 0 "text") (cons 8 "habitacion"))))
		(if conj (rellenacuadro) (alert "no se han encontrado textos en la capa habitacion"))
		(setq m (+ m 1))
	)
)
(defun c:cuadrosupol ()
	(inivar)
	(c:capa2d)
;	(command "_-layer" "_off" "*" "" "")
	(nombrefich)
	(setq fich (open (strcat nombre "_sup.csv") "w"))
	(write-line (strcat "SUPERFICIES UTILES Y CONSTRUIDAS PLANTA " nombre1) fich)
	(write-line "" fich)
	(command "_-layer" "_on" "sucons*" "")
	(prompt "selecciona polilineas:")
	(setq conj3 (ssget))
	(if conj3 (procesasucons))
	(close fich)
	(if (> tot 0) (alert (strcat "Se ha creado un fichero llamado" nombre "_sup.csv " "en la carpeta del dibujo")))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sumatxt;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pide que seleccionemos textos, los suma y pide el lugar donde colocarlos.
;;Si no existe la capa texto la crea.
(defun operatxt ()	
	(setvar "textsize" 0.2)
	(setq nconj (sslength conj))
	(setq n 0)
	(setq tot 0)
	(repeat nconj 
		(setq lis (entget (ssname conj n)))
		(setq cap (cdr (assoc 8 lis)))
		(setq txt (cdr (assoc 1 lis)))
		(setq txt (atof txt))
		(setq tot (+ tot txt))
		(setq n (+ n 1))
	)
	(setq tot (rtos tot 2 2))
)	
(defun c:sumatxt ()
	(inivar)
	(setq ctrl (tblsearch "layer" "texto"))
	(if (= ctrl nil) (setq nomcap "texto" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setq ctrl t)
	(while ctrl
		(prompt "Designar textos") (terpri)
		(setq conj (ssget))
		(if (= conj nil) (setq ctrl nil) (operatxt))
	)				
	(c:capa2d)
	(setq p1 (getpoint "Introduce posición:")) (terpri)
	(command "_-layer" "_on" "texto" "")
	(setvar "clayer" cap)
	(setvar "osmode" 0)
	(command "_text" p1 "" "0" (strcat tot "m2"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sumatxtentre2;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pide que seleccionemos textos, los suma y pide el lugar donde colocarlos.
;;Si no existe la capa texto la crea.
(defun operatxtentre2 ()	
	(setvar "textsize" 0.2)
	(setq nconj (sslength conj))
	(setq n 0)
	(setq tot 0)
	(repeat nconj 
		(setq lis (entget (ssname conj n)))
		(setq cap (cdr (assoc 8 lis)))
		(setq txt (cdr (assoc 1 lis)))
		(setq txt (atof txt))
		(setq tot (+ tot txt))
		(setq n (+ n 1))
	)
	(setq tot (/ tot 2))
	(setq tot (rtos tot 2 2))
)	
(defun c:sumatxtentre2 ()
	(inivar)
	(setq ctrl (tblsearch "layer" "texto"))
	(if (= ctrl nil) (setq nomcap "texto" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setq ctrl t)
	(while ctrl
		(prompt "Designar textos") (terpri)
		(setq conj (ssget))
		(if (= conj nil) (setq ctrl nil) (operatxtentre2))
	)				
	(c:capa2d)
	(setq p1 (getpoint "Introduce posición:")) (terpri)
	(command "_-layer" "_on" "texto" "")
	(setvar "clayer" "texto")
	(setvar "osmode" 0)
	(command "_text" p1 "" "0" (strcat tot "m2"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sumapol;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pide que se seleccionen polilineas y suma sus areas. despues pide donde colocarlas.
(defun operapol ()	
	(setq nconj (sslength conj))
	(setq n 0)
	(setq tot 0)
	(repeat nconj 
		(setq pol (ssname conj n))
		(command "_area" "e" pol)
		(setq ar (getvar "area"))
		(setq tot (+ tot ar)) 
		(setq n (+ n 1))
	)
	(setq tot (rtos tot 2 2))
)	
(defun c:sumapol ()
	(inivar)
	(setq ctrl (tblsearch "layer" "texto"))
	(if (= ctrl nil) (setq nomcap "texto" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "texto" "")
	(setq ctrl t)
	(while ctrl
		(prompt "Designar polilineas") (terpri)
		(setq conj (ssget))
		(if (= conj nil) (setq ctrl nil) (operapol))
	)				
	(c:capa2d)
	(setq p1 (getpoint "Introduce posición:")) (terpri)
	(setvar "clayer" "texto")
	(setvar "osmode" 0)
	(command "_text" p1 "" "0" (strcat tot "m2"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;numera;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:numera ()
	(inivar)
	(setq ht 0.15)
	(setq ctrl t)
	(setq n (getreal "Numero de comienzo(1):"))
	(if (= n nil) (setq n 1))
	(while ctrl
		(setvar "osmode" 546)
		(setq p1 (getpoint "Esquina:"))
		(setq p2x (+ (/ ht 2) (car p1)))
		(setq p2y (+ (/ ht 3) (cadr p1)))
		(setq p2 (list p2x p2y))
		(setq cad1 (rtos n 2 0))
		(command "_text" p2 "" "0" cad1) 
		(setq n (+ n 1))
	)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;numeraconsup;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun escribeplaza ()
	(setq p0 (list (+ (car p0) 1) (+ (cadr p0) 1) 0))
	(command "_boundary" p0 "")
	(command "_area" "e" (entlast))
	(setq ar (getvar "area"))
	(setq ar (rtos ar 2 2))
	(setq p0b (list (car p0) (+ (* escal 1.5 0.15) (cadr p0)) 0))
	(c:capa2d)
	(setvar "clayer" "texto")
	(setvar "osmode" 0)
	(command "_text" p0 "" "0" (strcat ar "m2"))
	(setvar "clayer" "habitacion")
	(setq numtexto (itoa n))
	(command "_text" p0b "" "0" (strcat textoanum "-" numtexto))
	(setq n (+ n 1))
)
(defun c:numeraplazas ()
	(inivar)
	(setq ctrl (tblsearch "layer" "texto"))
	(if (= ctrl nil) (setq nomcap "texto" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setq ctrl (tblsearch "layer" "habitacion"))
	(if (= ctrl nil) (setq nomcap "habitacion" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setq ctrl (tblsearch "style" "cursoedif"))
	(if ctrl (setvar "textstyle" "cursoedif"))
	(setq escal nil)
	(setq escal (getreal "escala:"))
	(if (= escal nil) (setq escal 1.0))
	(setq textoanum (getstring "texto:"))
	(if (= textoanum nil) (setq textoanum "T"))
	(setvar "textsize" (* escal 0.15))
	(setq p0 t)
	(setq n (getreal "Numero de comienzo(1):"))
	(if (= n nil) (setq n 1))
	(while p0
		(c:capasup)
		(setvar "osmode" 32)
		(setq p0 (getpoint "Punto interior:"))
		(if p0 (escribeplaza))
	)
	(c:capa2d)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PROGRAMAS DE MEDICIONES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;midelineas;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa mide todas las lineas del dibujo
;;escribe las mediciones en un fichero csv diferenciando por el nombre de la capa y cons subtotales
(defun midelins ()
	(setq nconj (sslength conj))
	(setq m 0)
	(setq tot 0)
	(write-line cap fich)
	(write-line "" fich)
	(repeat nconj
		(setq listalin (entget (ssname conj m)))
		(setq p1 (cdr (assoc 10 listalin)))
		(setq p2 (cdr (assoc 11 listalin)))
		(setq dis (distance p1 p2))
		(write-line (strcat (rtos dis) ";m") fich)
		(setq tot (+ tot dis))
		(setq m (+ m 1))
	)
	(write-line "" fich)
	(write-line "total" fich)
	(write-line (strcat (rtos tot) ";m") fich)
	(write-line "" fich)
)
;;;;subprograma que busca las lineas;;;;;;;;;;;;;;;;;;;
(defun buscalineas ()
	(setq ctrl0 nil ctrl2 nil)
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq ctrl0 (wcmatch nomcap "*|*"))
	(setq ctrl2 (ssget "x" (list (cons 0 "line") (cons 8 nomcap))))
	(if (and (= ctrl0 nil) ctrl2)
		(setq lista (cons nomcap lista))
	)
)
;;;;hace una lista con las capas a tratar en función de que contengan lineas.
(defun liscapdwglin ()
	(setq lista nil)
	(setq liscap (tblnext "layer" ""))
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq lista (cons nomcap lista))
	(while liscap
		(setq liscap (tblnext "layer"))
		(if liscap (buscalineas))
	)
	(setq lista (reverse lista))
	(setq nlista (length lista))
)
(defun c:midelineas ()
	(setq dir (getvar "dwgprefix"))
	(setq fich (open (strcat dir "medicion_lineas.csv") "w"))
	(write-line "medicion de lineas del dibujo" fich)
	(write-line "" fich)
	(write-line "longitud;ud" fich)
	(write-line "" fich)
	(liscapdwglin)
	(setq n 0)
	(repeat nlista
		(setq cap (nth n lista))
		(setq p 0.0 z 0.0 h 0.0)
		(setq conj (ssget "x" (list (cons 0 "line") (cons 8 cap))))
		(if conj (midelins))
		(setq n (+ n 1))
	)
	(close fich)
	(alert "he medido las lineas y lo he almacencenado en la carpeta del dibujo")
	(command "shell" (strcat "notepad " dir "medicion_lineas.csv"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;mideregiones;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Este programa ya es para medir en 3d. Se supone que hemos levantado en 3d con regiones a partir de lineas.
;;La cosa es sencilla. No nos pide nada. Busca las regiones como buscaba las lineas, calcula su area y las escribe
;;en un fichero csv.
(defun midereg ()
	(setq nconj (sslength conj))
	(setq m 0)
	(setq tot 0)
	(write-line cap fich)
	(write-line "" fich)
	(repeat nconj
		(setq listareg (entget (ssname conj m)))
		(setq ent (cdr (assoc -1 listareg)))
		(setq ar (vlax-get (vlax-ename->vla-object ent) 'Area))
		(write-line (strcat (rtos ar) ";m2") fich)
		(setq tot (+ tot ar))
		(setq m (+ m 1))
	)
	(write-line "" fich)
	(write-line "total" fich)
	(write-line (strcat (rtos tot) ";m2") fich)
	(write-line "" fich)
)
;;;;subprograma que busca las regiones;;;;;;;;;;;;;;;;;;;
(defun buscaregiones ()
	(setq ctrl0 nil ctrl2 nil)
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq ctrl0 (wcmatch nomcap "*|*"))
	(setq ctrl2 (ssget "x" (list (cons 0 "region") (cons 8 nomcap))))
	(if (and (= ctrl0 nil) ctrl2)
		(setq lista (cons nomcap lista))
	)
)
;;;;hace una lista con las capas a tratar en función de que contengan regiones.
(defun liscapdwgreg ()
	(setq lista nil)
	(setq liscap (tblnext "layer" ""))
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq lista (cons nomcap lista))
	(while liscap
		(setq liscap (tblnext "layer"))
		(if liscap (buscaregiones))
	)
	(setq lista (reverse lista))
	(setq nlista (length lista))
)
(defun iniciamedreg ()
	(nombrefich)
	(setq fich (open (strcat dir "medicion_regiones_" nombre1 ".csv") "w"))
	(write-line (strcat "medicion de regiones del dibujo " nombre1) fich)
	(write-line "" fich)
	(write-line "area;ud" fich)
	(write-line "" fich)
	(liscapdwgreg)
	(setq n 0)
	(repeat nlista
		(setq cap (nth n lista))
		(setq p 0.0 z 0.0 h 0.0)
		(setq conj (ssget "x" (list (cons 0 "region") (cons 8 cap))))
		(if conj (midereg))
		(setq n (+ n 1))
	)
	(close fich)
	(alert "he medido las regiones y lo he almacencenado en la carpeta del dibujo")
	(command "shell" (strcat "notepad " dir "medicion_regiones_" nombre1 ".csv"))
)
(defun c:mideregiones ()
	(setq ctrl nil)
	(setq ctrl (ssget "x" (list (cons 0 "region"))))
	(if ctrl (iniciamedreg) (alert "No hay regiones"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;midepolilineas;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pregunta la capa de la entidades a medir pidiendo que selecciones una polilinea.
(defun mideplins ()
	(setq nconj (sslength conj))
	(setq m 0)
	(setq ar 0)
	(setq per 0)
	(write-line "" fich)
	(write-line cap fich)
	(repeat nconj
		(setq listapol (entget (ssname conj m)))
		(command "area" "obj" (ssname conj m))
		(write-line "" fich)
		(princ (strcat (rtos (getvar "area")) ";m2;") fich)
		(princ (strcat (rtos (getvar "perimeter")) ";m") fich)
		(setq ar (+ ar (getvar "area")))
		(setq per (+ per (getvar "perimeter")))
		(setq m (+ m 1))
	)
	(write-line "" fich)
	(write-line "total" fich)
	(write-line "" fich)
	(princ (strcat (rtos ar) ";m2;") fich)
	(princ (strcat (rtos per) ";m") fich)
	(write-line "" fich)
)
;;;;subprograma que busca las polilineas;;;;;;;;;;;;;;;;;;;
(defun buscapolilineas ()
	(setq ctrl0 nil ctrl2 nil)
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq ctrl0 (wcmatch nomcap "*|*"))
	(setq ctrl2 (ssget "x" (list (cons 0 "lwpolyline") (cons 8 nomcap))))
	(if (and (= ctrl0 nil) ctrl2)
		(setq lista (cons nomcap lista))
	)
)
;;;;hace una lista con las capas a tratar en función de que contengan polilineas.
(defun liscapdwgplin ()
	(setq lista nil)
	(setq liscap (tblnext "layer" ""))
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq lista (cons nomcap lista))
	(while liscap
		(setq liscap (tblnext "layer"))
		(if liscap (buscapolilineas))
	)
	(setq lista (reverse lista))
	(setq nlista (length lista))
)
(defun c:midepolilineas ()
	(setq dir (getvar "dwgprefix"))
	(setq fich (open (strcat dir "medicion_polilineas.csv") "w"))
	(write-line "medicion de polilineas del dibujo" fich)
	(write-line "" fich)
	(write-line "area;ud;perimetro;ud" fich)
	(write-line "" fich)
	(liscapdwgplin)
	(setq n 0)
	(repeat nlista
		(setq cap (nth n lista))
		(setq p 0.0 z 0.0 h 0.0)
		(setq conj (ssget "x" (list (cons 0 "lwpolyline") (cons 8 cap))))
		(if conj (mideplins))
		(setq n (+ n 1))
	)
	(close fich)
	(alert "he medido las polilineas y lo he almacencenado en la carpeta del dibujo")
	(command "shell" (strcat "notepad " dir "medicion_polilineas.csv"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;midebloques;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun mideblqs ()
	(setq fich (open (strcat dir "medicion_bloques_nombre_" nombre ".csv") "w"))
	(setq conj (ssget "x" (list (cons 0 "insert") (cons 2 nombre))))
	(setq nconj (sslength conj))
	(write-line "bloque;ud" fich)
	(write-line (strcat (itoa nconj) ";ud") fich)
	(close fich)
	(alert (strcat "he medido los bloques " nombre " y lo he almacencenado en la carpeta del dibujo"))
	(command "shell" (strcat "notepad " dir "medicion_bloques_nombre_" nombre ".csv"))
)
(defun sacacapablq ()
	(setq dir (getvar "dwgprefix"))
	(setq lista (entget (ssname conj 0)))
	(setq cap (cdr (assoc 8 lista)))
	(setq nombre (cdr (assoc 2 lista)))
	(setq tipoent (cdr (assoc 0 lista)))
	(if (= tipoent "INSERT") (mideblqs) (alert "Lo seleccionado no es un bloque"))
)
(defun c:midebloques ()
	(prompt "Selecciona bloque a medir:")
	(setq conj (ssget))
	(if conj (sacacapablq) (alert "no se ha seleccionado ningun bloque"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;estruc;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;pone un punto en el centro de los pilares
(defun verticespilar ()
	(setq m 0)
	(setq num2 (length lis_ent))
	(setq lis_ptos nil)
	(repeat num2
		(setq elem (nth m lis_ent))
		(if (= (car elem) 10) (setq lis_ptos (cons elem lis_ptos)))
		(setq m (+ m 1))
	)
	(setq lis_ptos (reverse lis_ptos))
)
(defun ponestruc ()
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lis_ent (entget (ssname conj n)))
		(verticespilar)
		(setq p1 (list (cadr (nth 0 lis_ptos)) (caddr (nth 0 lis_ptos))))
		(setq p2 (list (cadr (nth 1 lis_ptos)) (caddr (nth 1 lis_ptos))))
		(setq p3 (list (cadr (nth 2 lis_ptos)) (caddr (nth 2 lis_ptos))))
		(setq p4 (list (cadr (nth 3 lis_ptos)) (caddr (nth 3 lis_ptos))))
		(setq p0 (inters p1 p3 p2 p4))
		(if p0 (command "_point" p0))
		(setq n (+ n 1))
	)
)
(defun c:estruc ()
	(inivar)
	(setvar "pdmode" 2)
	(setq conj (ssget "x" (list (cons 0 "lwpolyline") (cons 8 "pilar1"))))
	(if conj (ponestruc) (alert "¡¡¡¡no he encontrado ninguna polilinea en la capa pilar1!!!!"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;carpinte;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;si el dwg es un pl-cot crea el plano de carpinterias. Si es un dibujo normal pone textos de referencia
;;en las carpinterias que sean bloques
(defun anotapuerta ()
	(setq nblq (sslength conj))
	(setq n 0)
	(repeat nblq
		(setq lista (entget (ssname conj n)))
		(setq nomblq (cdr (assoc 2 lista)))
		(write-line nomblq fich) 
		(setq trozo1 (substr nomblq 1 2))
		(setq trozo2 (substr nomblq 5 3))
		(setq trozo3 (substr nomblq 9 3))
		(setq trozo4 (substr nomblq 13 2))
		(setq p0 (cdr (assoc 10 lista)))
		(setq fx (cdr (assoc 41 lista)))
		(setq fy (cdr (assoc 42 lista)))
		(setq ang (cdr (assoc 50 lista)))
		(setq cad (atof (substr nomblq 5 4)))
		(if (> cad 999) (setq f 1000) (setq f 100))
		(setq largo (/ cad f))
		(setq sumatrozos (+ (atoi trozo2) (atoi trozo3) (atoi trozo4)))
		(setq nomblq2 (strcat trozo1 (itoa sumatrozos)))
		(setq p1 (polar p0 ang (* (/ largo 2) fx)))
		(setq p2 (polar p1 (+ ang (/ pi 2)) 0.2))
		(if (= (abs (/ (* ang 180) pi)) 180) (setq ang 0)) 
		(command "_text" "_j" "_c" p2 0.2 (/ (* ang 180) pi) nomblq2)
		(setq n (+ n 1))
	)
)
(defun plantacarp ()
	(setq conj (ssget "x" (list (cons 8 "carpinte*") (cons 0 "text"))))
	(if conj (command "_delete" conj ""))
	(setq fich (open (strcat dir nombre1 "_carp.txt") "w"))
	(setq conj (ssget "x" (list (cons 8 "2d-ventana") (cons 0 "insert"))))
	(if conj (anotapuerta))
	(setq conj (ssget "x" (list (cons 8 "2d-puerta") (cons 0 "insert"))))
	(if conj (anotapuerta))
	(close fich)
)
(defun memocarp ()
	(setq trozo1 (substr elem 1 2))
	(setq trozo2 (substr elem 5 3))
	(setq trozo3 (substr elem 9 3))
	(setq trozo4 (substr elem 13 2))
	(setq sumatrozos (+ (atoi trozo2) (atoi trozo3) (atoi trozo4)))
	(setq nombre2 (strcat trozo1 (itoa sumatrozos)))
	(setq blq (findfile (strcat dirprograma "/bloques/carpinterias/" elem ".dwg")))
	(if (= blq nil) (alert (strcat "no se ha encontrado el bloque " elem)))
	(setq p2 (list (car p1) (- (cadr p1) 0.5) (caddr p1)))
	(command "_text" p2 0.2 0 nombre2)
	(setq num (itoa num))
	(setq cad (strcat "Nº UNIDADES=" num))
	(setq p3 (list (car p1) (- (cadr p1) 0.7) 0))
	(setq p4 (list (car p1) (- (cadr p1) 0.9) 0))
	(command "_text" p3 0.15 0 cad)
	(setq letra (substr elem 1 2))
	(cond
		((or (= letra "pm") (= letra "pv")) (command "_text" p4 0.15 0 "MADERA"))
		((or (= letra "pb") (= letra "vc") (= letra "vb") (= letra "pg") (= letra "pz")) (command "_text" p4 0.15 0 "ALUMINIO"))
		((= letra "pf") (command "_text" p4 0 "PUERTA RF"))
		((= letra "pt") (command "_text" p4 0 "METALICA"))
		((= letra "pe") (command "_text" p4 0 "BLINDADA"))
	)
	(if blq (command "_insert" blq p1 "" "" ""))
	(setq p1 (list (+ (car p1) 5) (cadr p1) (caddr p1)))
)
(defun cuentacarp ()
	(setq fich (open (strcat dir "pl-cot_carp.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich))
		(if (= lin elem) (setq num (+ num 1)))
	)
	(close fich)
)
(defun listacarp ()
	(setq fich2 (open (strcat dir nomrefx "_carp.txt") "r"))
	(setq lin t)
	(while lin
		(setq lin (read-line fich2))
		(if lin (write-line lin fich1))
		(if (and lin (= (member lin lista) nil)) (setq lista (cons lin lista)))
	)
	(close fich2)
)
(defun carprefx ()
	(setq lista nil)
	(setq fich1 (open (strcat dir "pl-cot_carp.txt") "w"))
	(setq p1 (getpoint "punto de insercion:"))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lisrefx (entget (ssname conj n)))
		(setq nomrefx (cdr (assoc 2 lisrefx)))
		(if (findfile (strcat dir nomrefx "_carp.txt")) (listacarp))
		(setq n (+ n 1))
	)
	(close fich1)
	(setq nlista (length lista))
	(setq m 0)
	(repeat nlista
		(setq elem (nth m lista))
		(setq num 0)
		(cuentacarp)
		(memocarp)
		(setq m (+ m 1))
	)
	(c:capac)
	(c:capref)
)
(defun planoscarp ()
	(setq conj (ssget "x" (list (cons 0 "insert") (cons 8 "0"))))
	(if conj (carprefx))
)
(defun c:carpinte ()
	(inivar)
	(setvar "textsize" 0.15)
	(setq ctrl (tblsearch "layer" "carpinte1"))
	(if (= ctrl nil) (setq nomcap "carpinte1" colorcap 7 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "carpinte1" "")
	(setq ctrl (tblsearch "layer" "carpinte2"))
	(if (= ctrl nil) (setq nomcap "carpinte2" colorcap 7 grosorcap 80.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "carpinte2" "")
	(setvar "clayer" "carpinte2")
	(nombrefich)
	(if (= nombre1 "pl-cot") (planoscarp) (plantacarp))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;PROGRAMAS DE CREACION DE PUERTAS EN 2D;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;abrehueco;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa para abrir hueco en muro o tabique. Pide, con referencia a punto cercano 2 puntos.
;;el primero en una de las lineas y el otro en la otra.
;;Luego pide con referencia a punto interseccion otro
;;a partir del cual calculara la posición del corte.
(defun c:abrehueco ()
	(inivar)
	(setq p1 nil p2 nil p0 nil ancho nil dis nil)
	(setvar "osmode" 512)
	(while (= p1 nil) (setq p1 (getpoint "punto1:")))
	(setq conj (ssget p1))
	(setq lista (entget (ssname conj 0)))
	(setq cap (cdr (assoc 8 lista)))
	(while (= p2 nil) (setq p2 (getpoint "punto2:")))
	(setvar "osmode" 32)
	(while (= p0 nil) (setq p0 (getpoint "punto de referencia:")))
	(setvar "osmode" 0)
	(setq ancho (getreal "ancho(0.85):"))
	(if (= ancho nil) (setq ancho 0.85))
	(setq dis (getreal "distancia(0.05):"))
	(if (= dis nil) (setq dis 0.05))
	(setq ang1 (angle p0 p1))
	(setq ang2 (+ ang1 (/ pi 2)))
;;hallamos el espesor del muro
	(setq p3 (polar p1 ang2 1))
	(setq p4 (polar p2 ang1 1))
	(setq p5 (inters p1 p3 p2 p4 nil))
	(setq e (distance p1 p5))
	(setq ang2 (angle p1 p5))
;;ya podemos construir y cortar el muro
	(setq p01 (polar p0 ang1 dis))
	(setq p03 (polar p01 ang2 e))
	(setq p02 (polar p01 ang1 ancho))
	(setq p04 (polar p02 ang2 e))
	(command "_break" p01 p02)
	(command "_break" p03 p04)
	(setvar "clayer" cap)
	(command "_line" p01 p03 "")
	(command "_line" p02 p04 "")
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;conspbat;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa para construir puertas en 2d macizas. Pide de forma grafica los puntos entre los que debe construir la puerta
;;el tercer punto que pide indica el grosor del tabique.
(defun cercospuerta ()
	(setq dis (distance p1 p2))
	(setq ang1 (angle p1 p2))
	(setq ang2 (angle p2 p3))
	(setq ang3 (angle p2 p1))
	(setq ancho (distance p2 p3))
;;primero construye los limites de la puerta.	
	(setq p1a (polar p1 ang1 0.05))
	(setq p1b (polar p1a ang2 ancho))
	(setq p1c (polar p1 ang2 ancho))
	(command "_pline" p1 p1a p1b p1c p1 "")
	(ssadd (entlast) conj)
;;va metiendo los elementos de la puerta en un conjunto
	(setq conj (ssadd))
	(setq p2a (polar p2 ang3 0.05))
	(setq p2b (polar p2a ang2 ancho))
	(setq p2c (polar p2 ang2 ancho))
	(command "_pline" p2 p2a p2b p2c p2 "")
	(ssadd (entlast) conj)
;;luego el dintel de arriba de la puerta
	(setvar "clayer" "2d-contorno")
	(command "_pline" p1 p2 p2c p1c p1 "")
;;lo quito para que no duplique contornos.
;;	(ssadd (entlast) conj)
	(setvar "clayer" "2d-puerta")
)
(defun c:conspbat ()
	(inivar)
;;el programa, por si acaso, busca las capas que necesita. si no estan las crea.
	(setq ctrl (tblsearch "layer" "2d-contorno"))
	(if (= ctrl nil) (setq nomcap "2d-contorno" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-contorno" "")
	(setq ctrl (tblsearch "layer" "2d-puerta"))
	(if (= ctrl nil) (setq nomcap "2d-puerta" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-puerta" "")
	(setvar "clayer" "2d-puerta")
;;pide los puntos entre los que hace la puerta y el numero de hojas.
	(setvar "osmode" 32)
	(setq p1 (getpoint "Punto1:"))
	(setq p2 (getpoint "Punto2:"))
	(setq p3 (getpoint "Punto3:"))
	(setvar "osmode" 0)
	(setq n nil)
	(setq n (getint "numero de hojas(1):"))
	(if (= n nil) (setq n 1))
;;prepara un conjunto llamado conj para ir añadiendo entidades
;;es necesario cuando hay mas de 1 hoja.
	(setq conj (ssadd))
;;llama al subprograma de construir los cercos laterales de la puerta, sus tapajuntas y su dintel.
	(cercospuerta)
	(setq largo (distance p1a p2a))
	(if (= n 2) (setq largo (/ largo 2)))
	(setq p1 p1a p2 p2a)
	(setq pm1 (polar p1 ang1 largo))
	(setq pm2 (polar pm1 (+ ang1 (/ pi 2)) 1))
	(setq p1a (polar p1 ang1 0.04))
	(setq p1b (polar p1a (+ ang2 pi) largo))
	(setq p1c (polar p1 (+ ang2 pi) largo))
	(command "_pline" p1 p1a p1b p1c p1 "")
	(ssadd (entlast) conj)
	(command "_arc" p1b "_e" pm1 "_d" (polar p1b ang1 1))
	(ssadd (entlast) conj)
	(if (= n 2) (command "_mirror" conj "" pm1 pm2 ""))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;consvbat;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa para construir ventanas batientes en 2d. Pide de forma grafica los puntos entre los que debe construir la ventana un tercer punto
;;que indica el grosor del muro y hacia donde se construye la ventana. luego pregunta numero de hojas y demas parametros necesarios.
(defun c:consvbat ()
	(inivar)
;;el programa, por si acaso, busca las capas que necesita. si no estan las crea.
	(setq ctrl (tblsearch "layer" "2d-contorno"))
	(if (= ctrl nil) (setq nomcap "2d-contorno" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-contorno" "")
	(setq ctrl (tblsearch "layer" "2d-ventana"))
	(if (= ctrl nil) (setq nomcap "2d-ventana" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-ventana" "")
	(setvar "clayer" "2d-ventana")
;;pide los 3 puntos poniendose en referencia a objetos interseccion. Tambien calcula los angulos para crear nuevos puntos.
	(setvar "osmode" 32)
	(setq p1 (getpoint "Punto1:"))
	(setq p2 (getpoint "Punto2:"))
	(setq p3 (getpoint "Punto3:"))
	(setvar "osmode" 0)
	(setq n (getint "numero de hojas(1):"))
	(if (= n nil) (setq n 1))
	(setq dis (distance p1 p2))
	(setq ang1 (angle p1 p2))
	(setq ang2 (angle p2 p3))
	(setq ang3 (angle p2 p1))
	(setq ang4 (angle p3 p2))
;;fabrica el vierteaguas
	(setq ancho (distance p2 p3))
	(setq p1a (polar p1 ang2 0.1))
	(setq p1b (polar p1 ang2 (+ ancho 0.03)))
	(setq p2a (polar p2 ang2 0.1))
	(setq p2b (polar p2 ang2 (+ ancho 0.03)))
	(command "_pline" p1a p1b p2b p2a p1a "")
;;fabrica los cercos limite de la ventana.	
	(setq p1a (polar p1 ang1 0.05))
	(setq p1b (polar p1a ang2 0.1))
	(setq p1c (polar p1 ang2 0.1))
	(command "_pline" p1 p1a p1b p1c p1 "")
	(setq p2a (polar p2 ang3 0.05))
	(setq p2b (polar p2a ang2 0.1))
	(setq p2c (polar p2 ang2 0.1))
	(command "_pline" p2 p2a p2b p2c p2 "")
	(setvar "clayer" "2d-contorno")
	(command "_pline" p1 p2 p2c p1c p1 "")
	(setvar "clayer" "2d-ventana")
;;prepara un conjunto llamado conj para ir añadiendo entidades que seran los componentes de la hoja
;;si son mas de 1 hay que hacer una matriz que dibuje n veces
	(setq conj (ssadd))
;;despues fabrica las hojas el valor de p1 le sirve pero p2 lo recalcula.
	(setq dis2 (/ (- dis 0.1) n))
	(setq p2 (polar p1 ang1 (+ 0.05 dis2)))
	(setq p1 p1a)
	(setq p1a (polar p1 ang1 0.05))
	(setq p1b (polar p1a ang2 0.05))
	(setq p1c (polar p1 ang2 0.05))
	(command "_pline" p1 p1a p1b p1c p1 "")
	(ssadd (entlast) conj)
	(setq p2a (polar p2 ang3 0.05))
	(setq p2b (polar p2a ang2 0.05))
	(setq p2c (polar p2 ang2 0.05))
	(command "_pline" p2 p2a p2b p2c p2 "")
	(ssadd (entlast) conj)
	(command "_pline" p1a p1b p2b p2a p1a "")
	(ssadd (entlast) conj)
;;cristales
	(setq p1a2 (polar p1a ang2 0.02))
	(setq p1a3 (polar p1a ang2 0.03))
	(setq p2a2 (polar p2a ang2 0.02))
	(setq p2a3 (polar p2a ang2 0.03))
	(command "_pline" p1a2 p2a2 p2a3 p1a3 p1a2 "")
	(ssadd (entlast) conj)
	(command "_ucs" "_z" p1 p2)
	(command "_-array" conj "" "_r" "1" n p1 p2)
;;aqui es donde deberia meter todas las entidades que ha creado en un bloque
;;para ello deberia preguntarnos el nombre de ese bloque o llamarla directamente
	(command "_ucs" "_w")
	(finvar)
)
;;;;;;;;;;;;;;;;;;;PROGRAMAS DE CONSTRUCCION DE ELEMENTOS EN 3D;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;consescal3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa crea escaleras en 3d a partir del plano de la escalera  en 2d y textos con la numeracion
;;de los peldaños. ¡¡¡Muy importante, los textos tienen que estar en la capa escalera!!!!
(defun levantaescal3d ()
	(setq nconj (sslength conj))
	(setq hpel (/ h nconj))
	(setq h (- h hpel))
	(if (= g nil) (setq g (/ h nconj)))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq npel (cdr (assoc 1 lista)))
		(setq num (atof npel))
		(setq z (* (/ h nconj) num))
		(setq p0 (cdr (assoc 10 lista)))
		(command "_-boundary" p0 "")
		(command "_extrude" (entlast) "" g)
		(command "_move" (entlast) "" (list 0 0 0) (list 0 0 (- z g)))
		(setq n (+ n 1))
	)
)
(defun c:consescal3d ()
	(inivar)
	(setq ctrl (tblsearch "layer" "3d-escalera"))
	(if (= ctrl nil) (setq nomcap "3d-escalera" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(setvar "clayer" "0")
	(command "_-layer" "_off" "*" "" "")
	(command "_-layer" "_on" "2d-escalera" "")
	(command "_-layer" "_on" "3d-escalera" "")
	(setvar "clayer" "3d-escalera")
	(setq h (getreal "Altura de la escalera:"))
	(setq g (getreal "grosor de las pisas(enter=grosor pisa):"))
	(setq conj (ssget "x" (list (cons 0 "text") (cons 8 "2d-escalera"))))
	(if conj (levantaescal3d) (alert "No existen textos en la capa 2d-escalera"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;conspuer3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;sirve para construir la puerta en 3d a partir del rectangulo del hueco y las hojas
(defun c:conspuer3d ()
	(inivar)
;;peticion de datos
	(setq jp (getreal "jamba de la puerta:(0.09)"))
	(if (= jp nil) (setq jp 0.09))
	(setq gh (getreal "grosor de la hoja:(0.04)"))
	(if (= gh nil) (setq gh 0.04))
	(prompt "selecciona rectangulo del hueco:")
	(setq conj1 (ssget))
	(prompt "selecciona rectangulos de las hojas:")
	(setq conj2 (ssget))
	(setq p0 (getpoint "Selecciona punto central entre hojas:"))
;;creacion de capas
	(setq ctrl (tblsearch "layer" "2d-puerta"))
	(if (= ctrl nil) (setq nomcap "2d-puerta" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-puerta" "")
	(setq ctrl (tblsearch "layer" "c-puerta"))
	(if (= ctrl nil) (setq nomcap "c-puerta" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "c-puerta" "")
	(setq ctrl (tblsearch "layer" "c-cotas"))
	(if (= ctrl nil) (setq nomcap "c-cotas" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "c-cotas" "")
	(setq ctrl (tblsearch "layer" "3d-puerta"))
	(if (= ctrl nil) (setq nomcap "3d-puerta" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "3d-puerta" "")
	(setvar "clayer" "3d-puerta")
;;creacion del cerco de la puerta
	(command "_copy" (ssname conj1 0) "" (list 0 0 0) (list 0 0 0))
	(command "_extrude" (entlast) "" jp)
	(setq ent1 (entlast))
	(command "_offset" 0.05 (ssname conj1 0) p0 "")
	(command "_extrude" (entlast) "" jp)
	(setq ent2 (entlast))
	(command "_subtract" ent1 "" ent2 "")
	(setq ent3 (entlast))
	(setq conj3 (ssadd))
	(ssadd (entlast) conj3)
	(setq nconj (sslength conj2))
	(setq n 0)
	(repeat nconj
		(command "_copy" (ssname conj2 n) "" (list 0 0 0) (list 0 0 0))
		(command "_extrude" (entlast) "" jp)
		(setq ent4 (entlast))
		(command "_subtract" ent3 "" ent4 "")
		(setq n (+ n 1))
	)
	(ssadd (entlast) conj3)
;;creacion de las hojas de la puertas
	(setq n 0)
	(repeat nconj
		(command "_copy" (ssname conj2 n) "" (list 0 0 0) (list 0 0 0))
		(command "_extrude" (entlast) "" gh)
		(ssadd (entlast) conj3)
		(setq n (+ n 1))
	)
;;creacion de los tapajuntas
	(command "_offset" 0.025 (ssname conj1 0) p0 "")
	(command "_extrude" (entlast) "" 0.01)
	(setq ent5 (entlast))
	(command "_copy" (entlast) "" (list 0 0 0) (list 0 -0.2 0))
	(setq ent5b (entlast))
	(command "_offset" 0.025 (ssname conj1 0) (list (- (car p0) 5) (+ (cadr p0) 5) 0) "")
	(command "_extrude" (entlast) "" 0.01)
	(setq ent6 (entlast))
	(command "_subtract" ent6 "" ent5 "")
	(setq ent7 (entlast))
	(command "_rectang" (list -0.2 -0.2 0) (list 5 0 0))
	(command "_extrude" (entlast) "" 0.01)
	(setq ent8 (entlast))
	(command "_subtract" ent7 "" ent8 "")
	(setq ent9 (entlast))
	(command "_subtract" ent9 "" ent5b "")
	(command "_move" (entlast) "" (list 0 0 0) (list 0 0 -0.01))
	(ssadd (entlast) conj3)
	(command "_copy" (entlast) "" (list 0 0 0) (list 0 0 0))
	(command "_move" (entlast) "" (list 0 0 0) (list 0 0 (+ jp 0.01)))
	(ssadd (entlast) conj3)
;;rotacion 3d de todas las entidades
	(command "_rotate3d" conj3 "" (list 0 0 0) (list 1 0 0) 90)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;consventan3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;sirve para construir la ventana en 3d a partir del rectangulo del hueco y las hojas
;;va pidiendo datos. Luego nos pide que seleccionemos el rectangulo del hueco, despues los rectangulos de las hojas
(defun c:consvent3d ()
	(inivar)
;;peticion de datos
	(setq jp (getreal "jamba de la ventana:(0.1)"))
	(if (= jp nil) (setq jp 0.1))
	(setq gh (getreal "grosor de la hoja:(0.05)"))
	(if (= gh nil) (setq gh 0.05))
	(prompt "selecciona rectangulo del hueco:")
	(setq conj1 (ssget))
	(setq p0 (getpoint "Selecciona punto central del hueco:"))
;;creacion de capas
	(setq ctrl (tblsearch "layer" "2d-ventana"))
	(if (= ctrl nil) (setq nomcap "2d-ventana" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-ventana" "")
	(setq ctrl (tblsearch "layer" "2d-contorno"))
	(if (= ctrl nil) (setq nomcap "2d-contorno" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "2d-contorno" "")
	(setq ctrl (tblsearch "layer" "c-ventana"))
	(if (= ctrl nil) (setq nomcap "c-ventana" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "c-ventana" "")
	(setq ctrl (tblsearch "layer" "c-cotas"))
	(if (= ctrl nil) (setq nomcap "c-cotas" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "c-cotas" "")
	(setq ctrl (tblsearch "layer" "3d-cristal1"))
	(if (= ctrl nil) (setq nomcap "3d-cristal1" colorcap 142.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "3d-cristal1" "")
	(setq ctrl (tblsearch "layer" "3d-ventana"))
	(if (= ctrl nil) (setq nomcap "3d-ventana" colorcap 8.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "3d-ventana" "")
	(setvar "clayer" "3d-ventana")
;;creacion del cerco de la ventana
	(command "_copy" (ssname conj1 0) "" (list 0 0 0) (list 0 0 0))
	(command "_extrude" (entlast) "" jp)
	(setq ent1 (entlast))
	(command "_offset" 0.05 (ssname conj1 0) p0 "")
	(command "_extrude" (entlast) "" jp)
	(setq ent2 (entlast))
	(command "_subtract" ent1 "" ent2 "")
	(setq ent3 (entlast))
	(setq conj3 (ssadd))
	(ssadd (entlast) conj3)
;;creacion de los tapajuntas
	(command "_offset" 0.025 (ssname conj1 0) p0 "")
	(command "_extrude" (entlast) "" 0.01)
	(setq ent5 (entlast))
	(command "_offset" 0.025 (ssname conj1 0) (list (- (car p0) 5) (+ (caddr p0) 5) 0) "")
	(command "_extrude" (entlast) "" 0.01)
	(setq ent6 (entlast))
	(command "_subtract" ent6 "" ent5 "")
	(setq ent7 (entlast))
	(command "_move" (entlast) "" (list 0 0 0) (list 0 0 -0.01))
	(ssadd (entlast) conj3)
	(command "_copy" (entlast) "" (list 0 0 0) (list 0 0 0))
	(command "_move" (entlast) "" (list 0 0 0) (list 0 0 (+ jp 0.01)))
	(ssadd (entlast) conj3)
;;creacion de las hojas de la ventanas y los cristales
	(prompt "selecciona rectangulos de las hojas:")
	(setq conj2 (ssget))
	(setq nconj (sslength conj2))
	(setq n 0)
	(repeat nconj
		(command "_copy" (ssname conj2 n) "" (list 0 0 0) (list 0 0 0))
		(command "_extrude" (entlast) "" gh)
		(setq ent1 (entlast))
		(setq p0 (getpoint (strcat "centro de la hoja " (itoa n))))
		(command "_offset" 0.05 (ssname conj2 n) p0 "")
		(command "_extrude" (entlast) "" gh)
		(setq ent2 (entlast))
		(command "_subtract" ent1 "" ent2 "")
		(ssadd (entlast) conj3)
		(setvar "clayer" "3d-cristal1")
		(command "_offset" 0.05 (ssname conj2 n) p0 "")
		(command "_extrude" (entlast) "" 0.01)
		(command "_move" (entlast) "" (list 0 0 0) (list 0 0 0.02))
		(ssadd (entlast) conj3)
		(setvar "clayer" "3d-ventana")
		(setq n (+ n 1))
	)
;;rotacion 3d de todas las entidades
	(command "_rotate3d" conj3 "" (list 0 0 0) (list 1 0 0) 90)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PROGRAMAS DE CONSTRUCCION DE TERRENOS (TOPOGRAFIA);;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;terrenoptos;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;busca los textos en la capa terreno y realiza un sombreado de puntos con la escala que le digamos.
;;luego los lleva a su posicion segun la cota que marque el texto creando una nube de puntos del terreno.
(defun createrreno ()
	(inivar)
	(setvar "clayer" "terreno")
	(command "_-layer" "_off" "*" "" "")
	(setvar "clayer" "0")
	(setq escal (getreal "escala sombreado:"))
	(setq nconj (sslength conj))
	(setvar "clayer" "terreno")
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq cota (cdr (assoc 1 lista)))
		(setq p0 (cdr (assoc 10 lista)))
		(setq z (atof cota))
		(command "_-hatch" p0 "prop" "dots1" escal "0" "or" (list 0 0 0) "")
		(command "_move" (entlast) "" (list 0 0 0) (list 0 0 z))
		(setq n (+ n 1))
	)
	(finvar)
)
(defun c:terrenoptos ()
	(setq ctrl nil)
	(setq ctrl (tblsearch "layer" "terreno"))
	(if ctrl (setq conj (ssget "x" (list (cons 0 "text") (cons 8 "terreno")))) (alert "No existe la capa terreno"))
	(if conj (createrreno) (alert "No existen textos en la capa terreno"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;nubetxt;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa coge los puntos generados con el programa anterior, los descompone y genera un fichero de texto con las coordenadas.
(defun c:nubetxt ()
	(inivar)
	(setq conj (ssget "x" (list (cons 0 "hatch") (cons 8 "terreno"))))
	(if conj (command "_explode" conj))
	(setq dir (getvar "dwgprefix"))
	(setq fich (open (strcat dir "terreno.csv") "w"))
	(prompt "selecciona puntos:")
	(setq conj (ssget))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq p0 (cdr (assoc 10 lista)))
;si queremos pasarlo a freecad
;		(write-line (strcat (itoa (+ n 1)) "," (rtos (car p0) 2 3) "," (rtos (cadr p0) 2 3) "," (rtos (caddr p0))) fich)
;si lo queremos para bricscad
		(write-line (strcat (rtos (car p0) 2 3) "," (rtos (cadr p0) 2 3) "," (rtos (caddr p0))) fich)
		(setq n (+ n 1))
	)
	(close fich)
	(alert "Se ha creado el fichero terreno.csv en la carpeta del dibujo")
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;txtnube;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa es el inverso del anterior. abre un fichero csv que le digamos y genera los puntos que contiene en bricscad.
;;luego se le puede aplicar site o tinsurface para generar la malla o no.
(defun c:txtnube ()
	(setq dir (getvar "dwgprefix"))
	(setq fich (getfiled "selecciona el fichero con la lista de puntos:" dir "csv" 8))
	(if fich (setq fich (open fich "r")))
	(setq lin t)
		(while lin
			(setq lin (read-line fich))
			(if lin (command "_point" lin))
		)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PROGRAMAS DE PROYECTO DE EJECUCION;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;camaras;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa pone camaras en los muros y ejes en los tabiques.
(defun poncamara ()
	(setq p1a (polar p1 ang2 0.12))
	(setq p2a (polar p2 ang2 0.12))
	(setq ang (angle p1 p2))
	(setq p1c (polar p1a ang 0.12))
	(setq ang (angle p2 p1))
	(setq p2c (polar p2a ang 0.12))
	(setq p3c (polar p1c ang2 0.14))
	(setq p4c (polar p2c ang2 0.14))
	(setvar "clayer" "aislante1")
	(command "_line" p1c p2c "")
	(command "_line" p1c p3c "")
	(command "_line" p2c p4c "")
	(setvar "clayer" "enfoscado1")
	(command "_line" p3c p4c "")
)
(defun sentido ()
	(setq ang (angle p1 p2))
	(setq pm (polar p1 ang (/ (distance p1 p2) 2)))
	(setq pma (polar pm (+ ang (/ pi 2)) 0.50))
	(setq conj2 (ssget "_f" (list pm pma) (list (cons 0 "LINE") (cons 8 "yeso*"))))
	(if (= conj2 nil) (setq conj2 (ssget "_f" (list pm pma) (list (cons 0 "LINE") (cons 8 "alicata*")))))
	(if (= conj2 nil) (setq conj2 (ssget "_f" (list pm pma) (list (cons 0 "LWPOLYLINE") (cons 8 "pilar")))))
	(setq conj3 (ssget "_f" (list pm pma) (list (cons 0 "LINE") (cons 8 "ejemed*"))))
	(setq conj4 (ssget "_f" (list pm pma) (list (cons 0 "LINE") (cons 8 "enfoscado*"))))
	(if (and (= conj3 nil) (= conj4 nil) conj2) 
		(progn
			(setq ang2 (angle pm pma))
			(poncamara)
		)
	)
	(setq ang (angle p2 p1))
	(setq pmb (polar pm (+ ang (/ pi 2)) 0.5))
	(setq conj2 (ssget "_f" (list pm pmb) (list (cons 0 "LINE") (cons 8 "yeso*"))))
	(if (= conj2 nil) (setq conj2 (ssget "_f" (list pm pmb) (list (cons 0 "LINE") (cons 8 "alicata*")))))
	(if (= conj2 nil) (setq conj2 (ssget "_f" (list pm pmb) (list (cons 0 "LWPOLYLINE") (cons 8 "pilar")))))
	(setq conj3 (ssget "_f" (list pm pmb) (list (cons 0 "LINE") (cons 8 "ejemed*"))))
	(setq conj4 (ssget "_f" (list pm pmb) (list (cons 0 "LINE") (cons 8 "enfoscado*"))))
	(if (and (= conj3 nil) (= conj4 nil) conj2) 
		(progn
			(setq ang2 (angle pm pmb))
			(poncamara)
		)
	)
)
(defun ejetabi ()
	(setq lista2 (entget (ssname conj2 0)))
	(setq p1a (cdr (assoc 10 lista2)))
	(setq p2a (cdr (assoc 11 lista2)))
	(setq p3 (inters p1 p2 pma pmb nil))
	(setq p4 (inters p1a p2a pma pmb nil))
	(if p4 (setq dis (/ (distance p3 p4) 2)) (setq dis 0.1))
	(if p4 (setq ang (angle p3 p4)))
	(if (> (* dis 2) 0.19) (setvar "clayer" "ejemed") (setvar "clayer" "ejetabi"))
	(setq p1a (polar p1 ang dis))
	(setq p2a (polar p2 ang dis))
	(command "_line" p1a p2a "") 
)
(defun dintelejetabi ()
	(setq lista2 (entget (ssname conj2 0)))
	(setq p1a (cdr (assoc 10 lista2)))
	(setq p2a (cdr (assoc 11 lista2)))
	(setq p3 (inters p1 p2 pma pmb nil))
	(setq p4 (inters p1a p2a pma pmb nil))
	(if p4 (setq dis (/ (distance p3 p4) 2)) (setq dis 0.1))
	(if p4 (setq ang (angle p3 p4)))
	(if (> (* dis 2) 0.14) (setvar "clayer" "dintelejemed") (setvar "clayer" "dintelejetabi"))
	(setq p1a (polar p1 ang dis))
	(setq p2a (polar p2 ang dis))
	(command "_line" p1a p2a "") 
)
(defun iniciacamaras ()
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq p1 (cdr (assoc 10 lista)))
		(setq p2 (cdr (assoc 11 lista)))
		(setq ang (angle p1 p2))
		(setq pm (polar p1 ang (/ (distance p1 p2) 2)))
		(setq pma (polar pm (+ ang (/ pi 2)) 0.01))
		(setq pmb (polar pm (+ ang (/ pi 2)) 0.17))
		(setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "alicata*"))))
		(if (= conj2 nil) (setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "yeso*")))))
		(if (= conj2 nil) (setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "muro*")))))
		(if (= conj2 nil) (setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "prodema*")))))
		(setq conj3 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "ejetabi*"))))
		(setq conj4 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "enfoscado*"))))
		(setq conj5 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "ejemed*"))))
		(if (and (= conj3 nil) (= conj4 nil) (= conj5 nil) conj2) (ejetabi))
		(setq ang (angle p2 p1))
		(setq pma (polar pm (+ ang (/ pi 2)) 0.01))
		(setq pmb (polar pm (+ ang (/ pi 2)) 0.21))
		(setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "alicata*"))))
		(if (= conj2 nil) (setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "yeso*")))))
		(if (= conj2 nil) (setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "muro*")))))
		(if (= conj2 nil) (setq conj2 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "prodema*")))))
		(setq conj3 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "ejetabi*"))))
		(setq conj4 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "enfoscado*"))))
		(setq conj5 (ssget "_f" (list pma pmb) (list (cons 0 "LINE") (cons 8 "ejemed*"))))
		(if (and (= conj3 nil) (= conj4 nil) (= conj5 nil) conj2) (ejetabi))
		(setq n (+ n 1))
	)
)
(defun c:camaras ()
	(inivar)
	(setq cap (tblsearch "layer" "ejetabi"))
	(if (equal cap nil) (setq nomcap "ejetabi" colorcap 1.0 grosorcap 80.0))
	(if (equal cap nil) (creacapa))
	(command "_-layer" "_on" "ejetabi" "")
	(setq cap (tblsearch "layer" "ejemed"))
	(if (equal cap nil) (setq nomcap "ejemed" colorcap 2.0 grosorcap 80.0))
	(if (equal cap nil) (creacapa))
	(command "_-layer" "_on" "ejemed" "")
	(setq cap (tblsearch "layer" "aislante1"))
	(if (equal cap nil) (setq nomcap "aislante1" colorcap 72.0 grosorcap 80.0))
	(if (equal cap nil) (creacapa))
	(command "_-layer" "_on" "aislante1" "")
	(setq cap (tblsearch "layer" "enfoscado1"))
	(if (equal cap nil) (setq nomcap "enfoscado1" colorcap 15.0 grosorcap 80.0))
	(if (equal cap nil) (creacapa))
	(command "_-layer" "_on" "enfoscado1" "")
	(setq conj (ssget "x" '((-4 . "<OR") (8 . "alicata*") (8 . "yeso*") (-4 . "OR>"))))
	(if conj (iniciacamaras) (alert "No he encontrado lineas en la capa yeso ni alicata"))
	(setvar "clayer" "enfoscado1")
	(setq conj (ssget "x" '((-4 . "<OR") (8 . "muro*") (8 . "prodema*") (-4 . "OR>"))))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq p1 (cdr (assoc 10 lista)))
		(setq p2 (cdr (assoc 11 lista)))
		(if (> (distance p1 p2) 0.32) (sentido))
		(setq n (+ n 1))
	)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;calef;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa sirve para calcular las Kc de las habitaciones. Tambien calcula el numero de elementos
;;que necesita el radiador. El calculo es muy sencillo, se basa en multiplicar por 95 la superficie de la habitación
;;usa las superficies de la capa sutil que se supone que se han hecho con anterioridad
;;sino, dice que no se han hecho y recomienda hacerlas.
(defun textoscalef ()
	(setq kctot (* ar 95))
	(setq kctotkw (/ kctot 860))
	(setq kctot (rtos kctot 2 3))
	(setq kctxt (strcat kctot "Kc"))
	(setq kctotkw (rtos kctotkw 2 3))
	(setq kctxtkw (strcat kctotkw "Kw"))
	(setq nelem (fix (/ (* ar 95) 103)))
	(setq nelem (rtos nelem 2 2))
	(setq nelemtxt (strcat nelem " elem."))
	(setq ar (rtos ar 2 2))
	(setq sumptosx (apply '+ lisptosx))
	(setq numptosx (length lisptosx))
	(setq sumptosy (apply '+ lisptosy))
	(setq numptosy (length lisptosy))
	(setq p0 (list (/ sumptosx numptosx) (/ sumptosy numptosy) 0))
	(setq p0b (list (car p0) (- (cadr p0) 0.2) 0))
	(setq p0c (list (car p0b) (- (cadr p0b) 0.2) 0))
	(c:capains)
	(setvar "clayer" "i_calef")
	(command "_text" p0 "" "0" (strcat kctxt "-" kctxtkw))
	(command "_text" p0b "" "0" nelemtxt)
	(command "_text" p0c "" "0" "europa 600c")
)
(defun areacalef ()
	(c:capa2d)
	(setq nlisptos (length lisptos))
	(command "_area" (nth 0 lisptos))
	(setq m 1)
	(repeat (- nlisptos 1)
		(command (nth m lisptos))
		(setq m (+ m 1))
	)
	(command "")
	(setq ar (getvar "area"))
	(if (> ar 1) (textoscalef))
)
(defun supcalef ()
	(setvar "textsize" 0.15)
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(vertices)
		(areacalef)
		(setq n (+ n 1))
	)
)
(defun c:calcalef ()
	(inivar)
	(setq ctrl (tblsearch "layer" "i_calef"))
	(if (= ctrl nil) (setq nomcap "i_calef" colorcap 95.0 grosorcap 40.0))
	(if (= ctrl nil) (creacapa))
	(command "_-layer" "_on" "i_calef" "")
	(setq conj (ssget "x" (list (cons 8 "i_calef") (cons 0 "text"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "lwpolyline") (cons 8 "sutil"))))
	(if conj (supcalef) (alert "No puedo calcular. No se han realizado las polilineas de superficie de las habitaciones en la capa sutil"))
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;tabiques;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;sirve para hacer la memoria de tabiqueria
;;si el dwg es un pl-cot inserta los planos de los muros que contiene el proyecto.
;;Si es un dibujo de planta los contabiliza en un fichero
(defun c:tabiques ()
	(inivar)
	(setq dir (getvar "dwgprefix"))
	(nombrefich)
	(setq fich (open (strcat dir nombre1 "-tabi.txt") "w"))
;;busca muro1, que es un muro de ladrillo caravista-aislante-camara-tabicar de 7 y yeso
	(setq conj (ssget "x" (list (cons 8 "muro1") (cons 0 "line"))))
	(if conj (write-line "muro1" fich))
;;busca muro2, que es un muro de monocapa sobre ladrillo hueco doble-aislante-camara-tabicar de 7 y yeso
	(setq conj (ssget "x" (list (cons 8 "muro2") (cons 0 "line"))))
	(if conj (write-line "muro2" fich))
;;busca muro3, que es un muro medianero de doble tabique de 7 cm con aislante enmedio
	(setq conj (ssget "x" (list (cons 8 "muro3") (cons 0 "line"))))
	(if conj (write-line "muro3" fich))
;;busca muro4, es un muro de hormigon de sotano
	(setq conj (ssget "x" (list (cons 8 "muro4") (cons 0 "line"))))
	(if conj (write-line "muro4" fich))
	(setq conj (ssget "x" (list (cons 8 "muro5") (cons 0 "line"))))
	(if conj (write-line "muro5" fich))
	(setq conj (ssget "x" (list (cons 8 "muro6") (cons 0 "line"))))
	(if conj (write-line "muro6" fich))
;;busca ejetabi que es un tabique de 7 cm revestido por los 2 lados
	(setq conj (ssget "x" (list (cons 8 "ejetabi") (cons 0 "line"))))
	(if conj (write-line "ejetabi" fich))
;;busca ejemed que es un doble tabique de 7 con aislante en medio de lana de roca de 4 cm.
	(setq conj (ssget "x" (list (cons 8 "ejemed") (cons 0 "line"))))
	(if conj (write-line "ejemed" fich))
	(close fich)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;buscapolabiertas;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:buscapolabiertas ()
	(setq conj (ssget "x" (list (cons 71 1))))
	(if conj (command "_move" conj "" (list 0 0 0) (list 100 0 0)))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;colorcap2d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;algunos ficheros municipales de pdf, al pasarlos a dwg con adobe illustrator se crea una sola capa "capa1" 
;;con todas las entidades aunque cada una conserva el color
;;este programa trabaja con dibujos 2d que tienen todas sus entidades en la misma capa pero con distintos colores.
;;crea una capa por cada color (con el nombre del color de la capa) y va cambiando las entidades a esas capas.
;;por ultimo limpia el dibujo.sirve para los dibujos de planeamiento traducidos con el illustrator.
(defun c:colorcap2d ()
;;esta primera parte se desactivo. Servia para borrar solidos (sombreados solidos), sombreados, polilineas 3d y el trozo de caratula bajo los planos. 
;;	(setq conj (ssget "x" (list (cons 0 "solid"))))
;;	(if conj (command "_erase" conj ""))
;;	(setq conj (ssget "x" (list (cons 0 "hatch"))))
;;	(if conj (command "_erase" conj ""))
;;	(setq conj (ssget "x" (list (cons 0 "polyline"))))
;;	(if conj (command "_erase" conj ""))
;;	(setq p0 (list 0 0 0))
;;	(setq p1 (list 1680 145 0))
;;	(command "_erase" "_c" p0 p1 "")
	(setq conj (ssget "x"))
	(setq nelem (sslength conj))
	(setq n 0)
	(repeat nelem
		(setq lista (entget (ssname conj n)))
		(setq col (cdr (assoc 62 lista)))
;;aqui hubo que añadir un if para el caso en que el color de la entidad es "porcapa" o "bylayer". En ese caso la deja en la capa 1
		(if col (setq col (itoa col)) (setq col "Capa 1"))
		(setq cap (tblsearch "layer" col))
		(if (equal cap nil)
			(progn
				(command "_-layer" "_new" col "")
				(command "_-layer" "_color" col col "")
			)
		)
		(command "_chprop" (ssname conj n) "" "_layer" col "")
		(setq n (+ n 1))
	)
	(command "_purge" "_all" "" "n")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;colorcap3d;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;este programa trabaja con dibujos 3d que tienen todas sus caras3d en la misma capa pero con distintos colores.
;;crea una capa por cada color (con el nombre del color de la capa) y va cambiando las entidades a esas capas.
;;por ultimo limpia el dibujo.Sirve fundamentalmente para los dibujos de muebles descargados por internet
(defun c:colorcap3d ()
;;	(setq conj (ssget "x" (list (cons 0 "3dface"))))
	(setq conj (ssget "x" (list (cons 0 "polyline"))))
	(setq nelem (sslength conj))
	(setq n 0)
	(repeat nelem
		(setq lista (entget (ssname conj n)))
		(setq colcapa (cdr (assoc 62 lista)))
		(if colcapa (setq colcapa (itoa colcapa)) (setq colcapa "3"))
		(setq cap (tblsearch "layer" colcapa))
		(if (equal cap nil)
			(progn
				(command "_-layer" "_new" colcapa "")
				(command "_-layer" "_color" colcapa colcapa "")
			)
		)
		(command "_chprop" (ssname conj n) "" "_layer" colcapa "")
		(setq n (+ n 1))
	)
	(command "_purge" "_all" "" "n")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;programas de creacion web;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Empiezo aqui una serie de programas que sirven para generar paginas web
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;creawebexp;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;crea las carpetas y los ficheros correspondientes a un expediente;;;;;;;;;;;;;;;;;;;;;;;;;
(defun inicioweb ()
	(write-line "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>" fich)
	(write-line "<html xmlns='http://www.w3.org/1999/xhtml'>" fich)
	(write-line "<head>")
	(write-line "<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />" fich)
	(write-line (strcat "<title>" nombre "</title>") fich)
	(write-line "<link href='../../m3estilo.css' rel='stylesheet' type='text/css'>" fich)
	(write-line (strcat "<link rel='icon' sizes='32x32' href='" nombre ".ico'>") fich)
	(write-line "</head>" fich)
	(write-line "<hr></hr>" fich)
	(write-line "<body>" fich)
	(write-line "<center>" fich)
	(write-line "<table border='0' width='900' align='center' cellspacing='0'>" fich)
	(write-line "<tr>" fich)
	(write-line "<td bgcolor='grey' width='180' height='30'>" fich)
	(write-line "<div align='left'>" fich)
	(write-line "<a id='hiper1' href='../../index.html'>&nbsp;estudio&nbsp;de&nbsp;arquitectura</a>" fich)
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "<td width='427' height='30'>" fich)
	(write-line "<div align='left'>" fich)
	(write-line "<b id='ennegro'>m3&nbsp;arquitectos</b>" fich)
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "<td width='303' height='30'>" fich)
	(write-line "</td>" fich)
	(write-line "</tr>" fich)
	(write-line "<tr>" fich)
	(write-line "<td valign='center'>" fich)
	(write-line "<div align='left'>" fich)
)
(defun finalweb ()
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "</tr>" fich)
	(write-line "</table>" fich)
	(write-line "<hr></hr>" fich)
	(write-line "</center>" fich)
	(write-line "</body>" fich)
	(write-line "</html>" fich)
)
(defun c:creawebexp ()
	(setq dir (getvar "dwgprefix"))
	(setq nombre (getstring "Nombre del cliente:"))
	(setq fich (open (strcat dir nombre ".html") "w"))
	(inicioweb)
	(write-line "<br><a id='hiper2' href='encargo/encargo.html'>encargo</a><br>" fich)
	(write-line "<a id='hiper2' href='anteproyecto/anteproyecto.html'>anteproyecto</a><br>" fich)
	(write-line "<a id='hiper2' href='basico/basico.html'>proyecto&nbsp;basico</a><br>" fich)
	(write-line "<a id='hiper2' href='ejecucion1/ejecucion1.html'>proyecto&nbsp;ejecucion</a><br>" fich)
	(write-line "<a id='hiper2' href='obra/obra.html'>direccion&nbsp;obra</a>" fich)
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "<td width='427' height='320'>" fich)
	(write-line "<div>" fich) 
	(write-line "<a href=''><image src='../../enproceso.gif' border='0'></a>" fich)
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "<td width='203' height='320'>" fich)
	(write-line "<div align='left'>" fich)
	(write-line "<p>Este es el espacio web privado de tu expediente.<br><br>" fich)
	(write-line "En el, iras encontrando los apartados que componen la documentacion necesaria.<br><br>" fich)
	(write-line "Para ver los documentos necesitaras un programa visualizador de ficheros pdf." fich)
	(write-line "Aunque, la mayoria de los navegadores los visualizan directamente, si no puedes verlos, te recomendamos este programa.</p>" fich)
	(write-line "<a id='hiper3' href='https://get.adobe.com/es/reader/'>adobe&nbsp;acrobat&nbsp;reader</a>" fich)
	(write-line "<p>Para ver la maqueta en realidad virtual, necesitas un</p>" fich)
	(write-line "<a id='hiper3' href='https://www.amazon.es/gp/product/B08MZVJJR2/ref=ox_sc_act_title_1?smid=AFUY5Y6AU69XI&psc=1'>casco VR</a>" fich)
	(write-line "<p>y un movil con giroscopio y el navegador web como el google chrome para movil.</p>" fich)
	(finalweb)
	(close fich)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;crea web fotos;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun iniciofotos ()
	(setq rutafichfotos (substr fichlista 1 (- (strlen fichlista) 7)))
	(setq fich (open (strcat rutafichfotos "fotos.html") "w"))
	(setq fich2 (open fichlista "r"))
	(write-line "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>" fich)
	(write-line "<html xmlns='http://www.w3.org/1999/xhtml'>" fich)
	(write-line "<head>" fich)
	(write-line "<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />" fich)
	(write-line "<title>m3arquitectos-fotos</title>" fich)
	(write-line "<link href='../../../../../m3estilo.css' rel='stylesheet' type='text/css'>" fich)
	(write-line "<link rel='stylesheet' href='../../../../../lightbox.min.css'>" fich)
	(write-line "</head>" fich)
	(write-line "<body>" fich)
	(write-line "<hr></hr>" fich)
	(write-line "<center>" fich)
	(write-line "<table border=0 align='center' cellspacing='0'>" fich)
	(write-line "<tr>" fich)
	(write-line "<td bgcolor='grey' width='170' height='30'>" fich)
	(write-line "<div align='left'>" fich)
	(write-line "<a id='hiper1' href='../../../../../index.html'>&nbsp;estudio&nbsp;de&nbsp;arquitectura&nbsp;</a>" fich)
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "<td width='170' height='30'>" fich)
	(write-line "<div align='left'>" fich)
	(write-line "<b id='ennegro'>m3&nbsp;arquitectos</b>" fich)
	(write-line "</div>" fich)
	(write-line "</td>" fich)
	(write-line "</tr>" fich)
	(write-line "<tr>" fich)
	(write-line "<td width='170' height='30'>" fich)
	(write-line "<a id='hiper2' href='../fotos.html'>volver</a>" fich)
	(write-line "</td>" fich)
	(write-line "</tr>" fich)
	(write-line "</table>" fich)
	(write-line "<div>" fich)
	(setq lin t)
	(while lin
		(setq lin (read-line fich2))
		(if lin (setq lin (substr lin 1 (- (strlen lin) 4))))
		(if lin (write-line (strcat "<a class='example-image-link' href='" lin ".jpg ' data-lightbox='example-set'><img class='example-image' src='tn_" lin ".jpg' alt=''/></a>") fich))
	)
	(write-line "</div>" fich)
	(write-line "<p>pulsa sobre la primera imagen para recorrer las vistas. para salir, pulsa fuera de la imagen</p>" fich)
	(write-line "<hr></hr>" fich)
	(write-line "</center>" fich)
	(write-line "<script src='../../../../../lightbox-plus-jquery.min.js'></script>" fich)
	(write-line "</body>" fich)
	(write-line "</html>" fich)
	(close fich2)
	(close fich)
)
(defun c:creawebfot ()
	(setq dir (getvar "dwgprefix"))
	(setq fichlista (getfiled "selecciona el fichero con la lista de fotos:" dir "txt" 8))
	(if fichlista (iniciofotos) (alert "no se ha seleccionado ningun fichero"))
;;el comando shell solo funciona con windows
;;	(command "shell" (strcat "dir -1 *.jpg > " dir "lista.txt"))
)
;;programas para macroestudio;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Inicio aqui un apartado de programas que he detectado necesario para adaptar mi forma de trabaja a macroestudios.
;;En las plantas que dibujan los arquitectos del macroestudio, hay lineas y polilineas mezcladas en capas que, solo deberian ser de un tipo de entidad.
;;Esto les ocurre mucho con las entidades situadas en capas de pilar o de muros
;;Para convertir un grupo de lineas en polilineas existe en autocad y bricscad la orden _join.
;;La podemos usar tanto para lineas de la capa muros como para lineas de la capa pilares.
;;Ademas las cierra para que luego se puedan usar en levantamientos 3d.
;;Otro problema son los bloques de las puertas. No cortan los muros.
;;Usan un sombreado blanco para evitarse el corte.
;;Eso les agiliza el dibujado y les permite mover la puerta en planta sin tener que reconstruir el muro.
;;No hace falta reconstruir ya que, simplemente, nunca se ha cortado.
;;Yo siempre corto el muro antes de colocar la puerta. En mi caso, al mover la puerta no reconstruye el muro.
;;Podria adaptar mi forma de dibujar a este sistema pero tiene un problema e cara a medicion. No mide el muro o tabique bien ya que mide sin huecos.
;;Otro problema que tiene su forma de delinear es que la mayoria de los bloques, tiene su punto de insercion muy lejos.
;;Esto tiene dificil solucion. Hay que rehacer los bloques.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;comiezo de programas para macroestudio;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa para hacer una lista de las capas del dibujo para poder luego crear el fichero txt de cambio de nombres a capas.
(defun c:capfichero ()
	(setq rutafich (getvar "dwgprefix"))
	(setq fich (open (strcat rutafich "capasfichero.txt") "w"))
	(setq lista nil)
	(setq liscap (tblnext "layer" ""))
	(setq nomcap (cdr (assoc 2 liscap)))
	(setq lista (cons nomcap lista))
	(write-line nomcap fich)
	(while liscap
		(setq liscap (tblnext "layer"))
		(if liscap (setq nomcap (cdr (assoc 2 liscap))))
		(if liscap (write-line nomcap fich))
	)
	(setq lista (reverse lista))
	(close fich)
)
;;programa que cambia los nombres, colores y grosores de las capas segun lo indicado en un fichero.
(defun c:normascapas ()
	(setq rutafich (getvar "dwgprefix"))
	(setq fich (getfiled "selecciona el fichero a abrir:" rutafich "txt" 8))
	(if fich (setq fich (open fich "r")))
	(setq capaori t)
	(while capaori
		(setq capaori (read-line fich))
		(if capaori (setq capacamb (read-line fich)))
		(if capaori (setq col (read-line fich)))
		(if capaori (setq grosor (read-line fich)))
		(if capaori (command "_-rename" "_layer" capaori capacamb))
		(if capaori (command "_-layer" "_color" col capacamb ""))
		(if capaori (command "_-layer" "_lweight" grosor capacamb ""))
	)
	(close fich)
)
;;Remplaza un bloque por otro. Pide elegir el bloque de cambio para buscarlo por las carpetas.
;;El programa inserta el bloque que se quiere cambiar para sacar su nombre y luego pide que se seleccione el bloque por el que se cambia.
;;Automaticamente remplaza el bloque usando el mismo punto de insercion, escala y giro.
(defun c:remplazabloque ()
	(inivar)
	(setq rutafich (getvar "dwgprefix"))
	(setq fich (getfiled "selecciona el fichero sustituto:" rutafich "dwg" 8))
	(if fich (command "_-insert" fich (list 0 0 0) 1 1 0))
	(setq lista (entget (entlast)))
	(setq nbl1 (cdr (assoc 2 lista)))
	(command "_erase" (entlast) "")
	(prompt "selecciona bloque a sustituir:")
	(setq conj (ssget))
	(setq lista (entget (ssname conj 0)))
	(setq nbl2 (cdr (assoc 2 lista)))
	(setq cap (cdr (assoc 8 lista)))
	(setq p0 (cdr (assoc 10 lista)))
	(setq ang (cdr (assoc 50 lista)))
	(setq ang (/ (* 180 ang) pi))
	(setq fx (cdr (assoc 41 lista)))
	(setq fy (cdr (assoc 42 lista)))
	(setvar "clayer" cap)
	(setq conj (ssget "x" (list (cons 0 "insert") (cons 2 nbl2))))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(setq lista (entget (ssname conj n)))
		(setq p0 (cdr (assoc 10 lista)))
		(setq ang (cdr (assoc 50 lista)))
		(setq ang (/ (* 180 ang) pi))
		(setq fx (cdr (assoc 41 lista)))
		(setq fy (cdr (assoc 42 lista)))
		(command "_erase" (ssname conj n) "")
		(command "_insert" nbl1 p0 fx fy ang)
		(setq n (+ n 1))
	)
	(finvar)
)
;Pide que se seleccione un bloque del dibujo para igualarlo con otro.
(defun c:igualabloque ()
	(inivar)
	(prompt "selecciona el bloque a imitar:")
	(setq conj (ssget))
	(setq lista (entget (ssname conj 0)))
	(setq nbl (cdr (assoc 2 lista)))
	(prompt "selecciona el bloque a sustituir:")
	(setq conj (ssget))
	(setq lista (entget (ssname conj 0)))
	(setq p0 (cdr (assoc 10 lista)))
	(setq ang (cdr (assoc 50 lista)))
	(setq ang (/ (* 180 ang) pi))
	(setq fx (cdr (assoc 41 lista)))
	(setq fy (cdr (assoc 42 lista)))
	(command "_erase" (ssname conj 0) "")
	(command "_insert" nbl p0 fx fy ang)
	(finvar)
)
;;programa para acotar de golpe un monton de lineas
;;hace una equidistancia de las lineas hacia el lado que le digamos y las acota. luego borra la linea equidistada.
;;si no existe la capa cotas la crea.
(defun c:acotalineas ()
	(inivar)
	(prompt "selecciona lineas a acotar:")
	(setq cap (tblsearch "layer" "cotas"))
	(if (equal cap nil) (setq nomcap "cotas" colorcap 8.0 grosorcap 20.0))
	(if (equal cap nil) (creacapa))
	(command "_-layer" "_on" "cotas" "")
	(setvar "clayer" "cotas")
	(setq conj (ssget))
	(setq p0 (getpoint "lado de acotacion:"))
	(setq nconj (sslength conj))
	(setq n 0)
	(repeat nconj
		(command "_offset" 0.5 (ssname conj n) p0 "")
		(setq ent1 (entlast))
		(setq lista1 (entget ent1))
		(setq p1 (cdr (assoc 10 lista1)))
		(setq p2 (cdr (assoc 11 lista1)))
		(command "_erase" (entlast) "")
		(command "_dimaligned" p1 p2 0)
		(setq n (+ n 1))
	)
	(finvar)
)
;;;;;;;;;;;;;;;;;;;;PROGRAMAS DE MEDICIONES Y PRESUPUESTO;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sacaref;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Este programa sirve para extraer la informacion de un fichero bc3.
;;la carpeta precios debe de estar creada en la carpeta cursoedif
;;dentro de ella aloja 3 ficheros. uno es capi.txt con los capitulos del presupuesto
;;la segunda es ref.txt con las referencias de las partidas y su nombre
;;la tercera es texto con los textos de las referencias.
(defun letracapi ()
	(setq letra1 (substr lin 7 1))
	(setq letra2 (substr lin 2 1))
;	(setq letra3 (substr lin 4 1))
;	(if (and (= letra1 "#") (= letra2 "C") (= letra3 "D")) (write-line (substr lin 4) fich2))
	(if (and (= letra1 "#") (= letra2 "C")) (write-line (substr lin 4) fich2))
)
(defun arreglacapi ()
	(setq nletras (strlen lin))
	(setq n 1)
	(setq m 0)
	(repeat nletras
		(setq letra (substr lin n 1))
		(if (and (/= letra "|") (< m 3)) (princ letra fich2) (setq m (+ m 1)))
		(if (= m 1) (write-line "" fich2))
		(setq n (+ n 1))
	)
	(write-line "" fich2)
)
(defun letraref ()
	(setq letra1 (wcmatch lin "*[#]*"))
	(setq letra2 (substr lin 2 1))
;	(setq letra3 (substr lin 4 1))
;	(if (and (= letra1 nil) (= letra2 "C") (= letra3 "D")) (write-line (substr lin 4) fich2))
	(if (and (= letra1 nil) (= letra2 "C")) (write-line (substr lin 4) fich2))
)
(defun arreglaref ()
	(setq nletras (strlen lin))
	(setq n 1)
	(setq m 0)
	(repeat nletras
		(setq letra (substr lin n 1))
		(if (and (/= letra "|") (< m 4)) (princ letra fich2) (setq m (+ m 1)))
		(if (and (= letra "|") (< m 4)) (write-line "" fich2))
		(setq n (+ n 1))
	)
	(write-line "" fich2)
)
(defun letratxt ()
	(setq letra1 (wcmatch lin "*[#]*"))
	(setq letra2 (substr lin 2 1))
;	(setq letra3 (substr lin 4 1))
;	(if (and (= letra1 nil) (= letra2 "T") (= letra3 "D")) (write-line (substr lin 4) fich2))
	(if (and (= letra1 nil) (= letra2 "T")) (write-line (substr lin 4) fich2))
)
(defun arreglatxt ()
	(setq nletras (strlen lin))
	(setq n 1)
	(setq m 0)
	(repeat nletras
		(setq letra (substr lin n 1))
		(if (and (/= letra "|") (< m 2)) (princ letra fich2) (setq m (+ m 1)))
		(if (and (= letra "|") (< m 2)) (write-line "" fich2))
		(setq n (+ n 1))
	)
	(write-line "" fich2)
)
(defun c:sacaref ()
	(setq fich (getfiled "archivo bc3 del que importar:" ruta "bc3" 8))
	(if fich
		(progn
			(setq fich1 (open fich "r"))
			(setq fich2 (open (strcat dirprograma "/precios/temp.txt") "w"))
			(setq lin t)
			(while lin
				(setq lin (read-line fich1))
				(if lin (letracapi))
			)
			(close fich2)
			(close fich1)
			(setq fich1 (open (strcat dirprograma "/precios/temp.txt") "r"))
			(setq fich2 (open (strcat dirprograma "/precios/capi.txt") "w"))
			(setq lin t)
			(while lin
				(setq lin (read-line fich1))
				(if lin (arreglacapi))
			)
			(close fich2)
			(close fich1)
			(setq fich1 (open fich "r"))
			(setq fich2 (open (strcat dirprograma "/precios/temp.txt") "w"))
			(setq lin t)
			(while lin
				(setq lin (read-line fich1))
				(if lin (letraref))
			)
			(close fich2)
			(close fich1)
			(setq fich1 (open (strcat dirprograma "/precios/temp.txt") "r"))
			(setq fich2 (open (strcat dirprograma "/precios/ref.txt") "w"))
			(setq lin t)
			(while lin
				(setq lin (read-line fich1))
				(if lin (arreglaref))
			)
			(close fich2)
			(close fich1)
			(setq fich1 (open fich "r"))
			(setq fich2 (open (strcat dirprograma "/precios/temp.txt") "w"))
			(setq lin t)
			(while lin
				(setq lin (read-line fich1))
				(if lin (letratxt))
			)
			(close fich2)
			(close fich1)
			(setq fich1 (open (strcat dirprograma "/precios/temp.txt") "r"))
			(setq fich2 (open (strcat dirprograma "/precios/textos.txt") "w"))
			(setq lin t)
			(while lin
				(setq lin (read-line fich1))
				(if lin (arreglatxt))
			)
			(close fich2)
			(close fich1)
		)
	)
	(command "shell" (strcat "del " ruta "precios/temp.txt"))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;presupbc3;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;programa que elabora un presupuesto en bc3 a partir de la informacion de 2 ficheros.
;;uno de capitulos y otro de partidas donde cada capa tenga sus datos.
;;sirve para importarlo luego en presto o arquimedes.
(defun midenumpolis ()
	(write-line "midenumpolis" fich3)
)
(defun midem2polis ()
	(write-line "midem2polis" fich3)
)
(defun midemlpolis ()
	(write-line "midemlpolis" fich3)
)
(defun midenumcir ()
	(write-line "midenumcir" fich3)
)
(defun midem2cir ()
	(write-line "midem2cir" fich3)
)
(defun midemlcir ()
	(write-line "midemlcir" fich3)
)
(defun midenumlin ()
	(write-line "midenumlin" fich3)
)
(defun midem2lin ()
	(write-line "midem2lin" fich3)
)
(defun midemllin ()
	(write-line "midemllin" fich3)
)
(defun mideblq ()
	(write-line "mideblq" fich3)
)
(defun midecapa ()
	(setq conj nil)
	(write-line (strcat "~M|" capicap "#\\" ref "|\\\\||") fich3)
;	(setq conj (ssget "x" (list (cons 0 "lwpolyline") (cons 8 cap))))
;	(if (and conj (= modomed ud)) (midenumpolis))
;	(if (and conj (= modomed m2)) (midem2polis))
;	(if (and conj (= modomed ml)) (midemlpolis))
;	(setq conj (ssget "x" (list (cons 0 "circle") (cons 8 cap))))
;	(if (and conj (= modomed ud)) (midenumcir))
;	(if (and conj (= modomed m2)) (midem2cir))
;	(if (and conj (= modomed ml)) (midemlcir))
;	(setq conj (ssget "x" (list (cons 0 "line") (cons 8 cap))))
;	(if (and conj (= modomed ud)) (midenumlin))
;	(if (and conj (= modomed m2)) (midem2lin))
;	(if (and conj (= modomed ml)) (midemllin))
;	(setq conj (ssget "x" (list (cons 0 "insert") (cons 8 cap))))
;	(if (and conj (= modomed ud)) (mideblq))
	(princ "|" fich3)
)
(defun midecapi ()
	(setq cap t)
	(while cap
		(setq cap (read-line fich2))
		(if cap (setq capicap (read-line fich2)))
		(if cap (setq modomed (read-line fich2)))
		(if cap (setq ref (read-line fich2)))
		(if (= capicap numcapi) (midecapa))
	)
)
;;Ahora mide todo el dibujo. Le da igual que este en 2d o 3d.
(defun creapresup ()
	(nombrefich)
;;Averigua la ruta del fichero dwg que queremos medir
;;Averigua el nombre del fichero.
;;Crea un fichero de capitulos. Si no existe un fichero llamado capi.txt creado a mano por nosotros
;;lo crea automaticamente basandose en uno ya hecho alojado en la carpeta de medicion.
	(setq fich (findfile (strcat dir "capitulos.txt")))
	(if (= fich nil)
		(progn
			(setq dato1 (strcat ruta "/medicion/capitulos.txt"))
			(setq dato2 (strcat dir "capitulos.txt"))
			(copiafich)
		)
	)
;;el de partidas si no existe, lo crea con las partidas clasicas copiando un fichero alojado en la carpeta de medicion.
;;Si no, nosotros seremos los que lo tendremos que rellenar.
;;Se rellena de la siguiente manera. Primero el nombre de la capa. Despues, el capitulo donde estara esa partida.
;;En tercer lugar, el modo de medir. Por ultimo, la referencia de la partida.
	(setq fich (findfile (strcat dir "partidas.txt")))
	(if (= fich nil)
		(progn
			(setq dato1 (strcat ruta "/medicion/partidas.txt"))
			(setq dato2 (strcat dir "partidas.txt"))
			(copiafich)
		)
	)
;;Comprueba tambien si existe el fichero de levantamiento. Si no existe porque aun no hemos levantado en 3d lo crea.
	(setq fich (findfile (strcat dir nombre1 "_2d3d.txt")))
	(if (= fich nil) (fichtipo2d3d))
;;Ahora que y a nos hemos asegurado de que tenemos los 3 ficheros necesarios, podemos proceder a medir.
;;Abrimos el fichero de capitulos, partidas y el fichero de medicion en bc3
;;Solo medira lo que este en el fichero de partidas y con el modo de medicion que figure.
;;Activamos todas las capas
	(command "_-layer" "_on" "*" "")
	(setq fich1 (open (strcat dir "capitulos.txt") "r"))
	(setq fich2 (open (strcat dir "partidas.txt") "r"))
	(setq fich3 (open (strcat dir "medicion.bc3") "w"))
	(setq numcapi t)
	(while numcapi
		(setq numcapi (read-line fich1))
		(if numcapi (setq txtcap (read-line fich1)))
		(if numcapi (midecapi))
	)
	(close fich3)
	(close fich2)
	(close fich1)
)
(defun c:presupbc3 ()
;;inicia el programa. Si no se ha guardado el dwg con un nombre nos lo dice con un alert.
	(setq guardaprev (getvar "dwgtitled"))
	(if (= guardaprev 0) (alert "No se ha guardado el dibujo todavia en ningun directorio") (creapresup))
;;Si ya se ha guardado entonces averigua si existen en la carpeta del dibujo los ficheros de capitulos y partidas.
;;Si no existen los crea.
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;simplificaskp;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;En el desarrollo de un proyecto, no podemos crear todos los bloques en 3d.
;;Necesitamos apoyarnos en bloques bajados de internet. Una de las paginas mas interesantes
;;es la de sketchup llamada 3dwharehouse. Permite buscar por palabras y permite descargarnos modelos 3d de todo tipo hechos por la gente.
;;Si los bajamos en dwg normalmente se compone de bloques anidados y contiene lineas, arcos textos.
;;Este programa se encarga de descomponer todos los bloques anidados. Despues, borra las lineas los arcos y,
;;demas entidades 2d que pudieran contener y deja solo las caras 3d.
;;Una vez simplicada a caras 3d, va capa por capa recogiendo las caras 3d y componiendolas en mallas policara.
(defun c:simplifiskp ()
	(setq conj t)
	(while conj
		(setq conj (ssget "x" (list (cons 0 "insert"))))
		(if conj (command "_explode" conj))
	)
	(setq conj (ssget "x" (list (cons 0 "line"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "arc"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "circle"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "text"))))
	(if conj (command "_erase" conj ""))
	(setq conj (ssget "x" (list (cons 0 "mtext"))))
	(if conj (command "_erase" conj ""))
)
